##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
#PALETTE=0 1 2 3 6 9 11 12 13 15 16 18 20 24 25 26
PALETTE=0 1 2 3 4 6 8 12 13 15 16 17 18 20 24 26
LEVEL_PALETTE= 0 1 2 4 5 7 8 10 11 14 16 17 20 23 24 26
## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
$(eval $(call IMG2SP, SET_FOLDER      , src/sprites/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }

$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), main_palette ))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(LEVEL_PALETTE), palette_level ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))

$(eval $(call IMG2SP, CONVERT         , img/border_izq_horizontal.png , 114, 3, border01_h_sp))
$(eval $(call IMG2SP, CONVERT         , img/border_izq_vertical.png , 2, 200, border01_v_sp))
$(eval $(call IMG2SP, CONVERT         , img/border02.png , 46, 200, border02_sp))

$(eval $(call IMG2SP, CONVERT         , img/Player_Dmg0/nave.png , 8, 8, spaceship_sp))
$(eval $(call IMG2SP, CONVERT         , img/Player_Dmg1/nave_dmg1.png , 8, 8, spaceship_sp_dmg1))
$(eval $(call IMG2SP, CONVERT         , img/Player_Dmg2/nave_dmg2.png , 8, 8, spaceship_sp_dmg2))

$(eval $(call IMG2SP, CONVERT         , img/Player_Dmg0/nave_immortal.png , 8, 8, spaceshipImmortal))

$(eval $(call IMG2SP, CONVERT         , img/Player_Dmg2/nave_death.png , 8, 8, spaceship_sp_death))

$(eval $(call IMG2SP, CONVERT         , img/zygon3.png , 10, 5, zygon3_sp,))
$(eval $(call IMG2SP, CONVERT         , img/zygon3_death.png , 10, 5, zygon3_death_sp))
$(eval $(call IMG2SP, CONVERT         , img/zygon2.png , 10, 5, zygon2_sp))
$(eval $(call IMG2SP, CONVERT         , img/zygon2_death.png , 10, 5, zygon2_death_sp))
$(eval $(call IMG2SP, CONVERT         , img/zygon1.png , 10, 5, zygon1_sp))
$(eval $(call IMG2SP, CONVERT         , img/zygon1_death.png , 10, 5, zygon1_death_sp))

$(eval $(call IMG2SP, CONVERT         , img/sideman.png , 10, 10, sideman_sp))
$(eval $(call IMG2SP, CONVERT         , img/sideman_death.png , 10, 10, sideman_sp_death))
$(eval $(call IMG2SP, CONVERT         , img/bullet_sideman.png , 2, 2, bullet_sideman))

$(eval $(call IMG2SP, CONVERT         , img/bala_simple1.png , 2, 2, bullet_simple_sp))
# $(eval $(call IMG2SP, CONVERT         , img/suriken1.png , 6, 6, bullet_suriken1_sp))
# $(eval $(call IMG2SP, CONVERT         , img/suriken2.png , 6, 6, bullet_suriken2_sp))
$(eval $(call IMG2SP, CONVERT         , img/bullet_zygon2.png , 4, 4, bullet_zygon2))
$(eval $(call IMG2SP, CONVERT         , img/bullet_bossT5.png , 4, 4, bullet_BT5))

$(eval $(call IMG2SP, CONVERT         , img/medical_kit2.png , 8, 8, medical_kit))
$(eval $(call IMG2SP, CONVERT         , img/item_bullet.png , 8, 8, item_bullet))
$(eval $(call IMG2SP, CONVERT         , img/hourglass.png , 8, 16, item_hourglass))

$(eval $(call IMG2SP, CONVERT         , img/letter_L.png , 20, 32, letter_L))
$(eval $(call IMG2SP, CONVERT         , img/letter_E.png , 20, 32, letter_E))
$(eval $(call IMG2SP, CONVERT         , img/letter_V.png , 20, 32, letter_V))

$(eval $(call IMG2SP, CONVERT         , img/letter_0.png , 20, 32, letter_0))
$(eval $(call IMG2SP, CONVERT         , img/letter_1.png , 20, 32, letter_1))
$(eval $(call IMG2SP, CONVERT         , img/letter_2.png , 20, 32, letter_2))
$(eval $(call IMG2SP, CONVERT         , img/letter_3.png , 20, 32, letter_3))
$(eval $(call IMG2SP, CONVERT         , img/letter_4.png , 20, 32, letter_4))
$(eval $(call IMG2SP, CONVERT         , img/letter_5.png , 20, 32, letter_5))
$(eval $(call IMG2SP, CONVERT         , img/letter_6.png , 20, 32, letter_6))
$(eval $(call IMG2SP, CONVERT         , img/letter_7.png , 20, 32, letter_7))
$(eval $(call IMG2SP, CONVERT         , img/letter_8.png , 20, 32, letter_8))
$(eval $(call IMG2SP, CONVERT         , img/letter_9.png , 20, 32, letter_9))

$(eval $(call IMG2SP, CONVERT         , img/enemy_red.png , 10, 16, enemy_red))

$(eval $(call IMG2SP, CONVERT         , img/boss_level1.png , 40, 40, enemy_boss1))
$(eval $(call IMG2SP, CONVERT         , img/boss_level1_death.png , 40, 40, enemy_boss1_death))



$(eval $(call IMG2SP, CONVERT         , img/son.png , 16, 16, son))
$(eval $(call IMG2SP, CONVERT         , img/son_death.png , 16, 16, son_death))

$(eval $(call IMG2SP, CONVERT         , img/eye_boss.png , 34, 50, eye_boss))
$(eval $(call IMG2SP, CONVERT         , img/eye_boss_death.png , 34, 50, eye_boss_death))

$(eval $(call IMG2SP, CONVERT         , img/eye_boss_closed.png , 34, 50, eye_boss_closed))
$(eval $(call IMG2SP, CONVERT         , img/eye_boss_damaged1.png , 34, 50, eye_boss_damaged1))
$(eval $(call IMG2SP, CONVERT         , img/eye_boss_damaged2.png , 34, 50, eye_boss_damaged2))

$(eval $(call IMG2SP, CONVERT         , img/eye_boss_son.png , 16, 36, eye_boss_son))
$(eval $(call IMG2SP, CONVERT         , img/eye_boss_son_death.png , 16, 36, eye_boss_son_death))

$(eval $(call IMG2SP, CONVERT         , img/boss_spaceship.png , 36, 20, boss_spaceship))
$(eval $(call IMG2SP, CONVERT         , img/boss_spaceship_damaged1.png , 36, 20, boss_spaceship_damaged1))
$(eval $(call IMG2SP, CONVERT         , img/boss_spaceship_damaged2.png , 36, 20, boss_spaceship_damaged2))
$(eval $(call IMG2SP, CONVERT         , img/boss_spaceship_damaged3.png , 36, 20, boss_spaceship_damaged3))
$(eval $(call IMG2SP, CONVERT         , img/boss_spaceship_death.png , 36, 20, boss_spaceship_death))
$(eval $(call IMG2SP, CONVERT         , img/misil.png , 8, 16, misil))
$(eval $(call IMG2SP, CONVERT         , img/misil_p.png , 4, 16, misil_p))
$(eval $(call IMG2SP, CONVERT         , img/misil_broken.png , 4, 8, misil_broken))
$(eval $(call IMG2SP, CONVERT         , img/misil_broken2.png , 4, 8, misil_broken2))

$(eval $(call IMG2SP, CONVERT         , img/spaceship_big.png , 40, 40, spaceship_big))
$(eval $(call IMG2SP, CONVERT         , img/spaceship_big_damaged1.png , 40, 40, spaceship_big_damaged1))
$(eval $(call IMG2SP, CONVERT         , img/spaceship_big_damaged2.png , 40, 40, spaceship_big_damaged2))
$(eval $(call IMG2SP, CONVERT         , img/spaceship_big_damaged3.png , 40, 40, spaceship_big_damaged3))

$(eval $(call IMG2SP, CONVERT         , img/logo_interface.png , 30, 28, logo_interface))
$(eval $(call IMG2SP, CONVERT         , img/smart_missile.png , 16, 16, smart_missile))
$(eval $(call IMG2SP, CONVERT         , img/bullet_final_boss.png , 4, 16, bullet_final_boss))

##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

# PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

#$(eval $(call IMG2SPRITES,img/example.png,0,pre,24,12,$(PALETTE),mask,src/,hwpalette))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################
