    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
    
;;
;; INTERFACE
;;

.include "cpctelera.h.s"
.area _DATA 

x_level = 61
y_level = 120
_lives: .asciz "3"

_counterLives: .db 0
_count: .db 0

_scoreIni: .asciz "0000"
_score: .asciz "0000"

.area _CODE 
;;INPUT
;;      A: color del fondo
;;      E: color de letra 
;;      B: coordenada y
;;      C: coordenada x
;;     IY: puntero al string
escribir:
    push bc

    ld    d, a                    ;; D = Background PEN (0)
    call cpct_setDrawCharM1_asm   ;; Set draw char colours

    ;; Calculate a video-memory location for printing a string
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    pop bc
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL    
     
    call cpct_drawStringM0_asm  ;; Draw the string
    ret

interface_init::

    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #58 ;; coordenada x
    ld b, #25 ;; coordenada y
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    ld a, #0 ;; Color del cuadro
    ld c, #21 ;;ancho
    ld b, #30 ;;alto
    call cpct_drawSolidBox_asm

    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #58 ;; coordenada x
    ld b, #170 ;; coordenada y
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    call get_spaceship_sprite
    ld a, #0 ;; Color del cuadro
    ld c, #21 ;;ancho
    ld b, #25 ;;alto
    call cpct_drawSolidBox_asm

    ld a, #1
    ld e, #6
    ld b, #180
    ld c, #60
    ld iy, #_score
    call escribir
    ;ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ;ld c, #1 ;; coordenada x
    ;ld b, #2 ;; coordenada y
    ;call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
;
    ;ex de, hl ;; Pasamos el valor a de
    ;ld a, #0 ;; Color del cuadro
    ;ld c, #12 ;;ancho
    ;ld b, #12 ;;alto
    ;call cpct_drawSolidBox_asm


    call interface_render_lives
    ret

interface_render_lives::

    call interface_lives_clean

    call get_spaceship_array_position
    ld a, e_lives(ix)

    ld (_counterLives), a
    cp #0x00
    ret z

    cp #0x05
    jp nz, three

    dec a
    ld (_counterLives), a

    ld a, #59
    ld (_count), a

    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #59 ;; coordenada x
    ld b, #42 ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_spaceship_sprite
    ld c, #4 ;;ancho
    ld b, #8 ;;alto
    call cpct_drawSprite_asm
    jp loop_Interface

    three:
    cp #0x03
    jp nz, two
    ld a, #61
    ld (_count), a
    jp loop_Interface

    two:
    cp #0x02
    jp nz, one
    ld a, #64
    ld (_count), a
    jp loop_Interface

    one:
    cp #0x01
    jp nz, four
    ld a, #67
    ld (_count), a
    jp loop_Interface

    four:
    cp #0x04
    ld a, #59
    ld (_count), a
    jp loop_Interface

    
    loop_Interface: 
    
    ld a, (_count)
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, a ;; coordenada x
    push af
    ld b, #30 ;; coordenada y
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    pop af
    add #5
    ld (_count), a

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_spaceship_sprite
    ld c, #4 ;;ancho
    ld b, #8 ;;alto
    call cpct_drawSprite_asm
    
    ld a , (_counterLives)
    dec a
    ret z
    ld (_counterLives), a

    jp loop_Interface

interface_draw_logo: 
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level ;; coordenada x
    ld b, #80 ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    ld hl, #_logo_interface
    ld c, #15 ;;ancho
    ld b, #28 ;;alto
    call cpct_drawSprite_asm
    ret
interface_lives_clean::
    ; ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ; ld c, #58 ;; coordenada x
    ; ld b, #25 ;; coordenada y
    ; call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ; ex de, hl ;; Pasamos el valor a de
    ; ld a, #0 ;; Color del cuadro
    ; ld c, #21 ;;ancho
    ; ld b, #30;;alto
    ; call cpct_drawSolidBox_asm
    call update_marco_derecha
    call interface_draw_score
    call interface_draw_level
    call interface_draw_logo
    ret

interface_draw_score::
    push ix 
    push af
    push bc
;; SCORE
    ld ix, #_score
    ld a, (_score_d1)
    add a, #0x30
    ld 3(ix), a
    ld a, (_score_d2)
    add a, #0x30
    ld 2(ix), a
    ld a, (_score_d3)
    add a, #0x30 
    ld 1(ix), a
    ld iy, #_score
    ld a, #1
    ld e, #6
    ld b, #180
    ld c, #60
    ld iy, #_score
    call escribir
    pop bc
    pop af
    pop ix
    ret

escribe_primer_0:
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level ;; coordenada x
    ld b, #y_level ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_0
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm
    ret

escribe_numero_1:
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level + 8;; coordenada x
    ld b, #y_level  ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_1
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm
    ret

escribe_numero_2:
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level +8;; coordenada x
    ld b, #y_level;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_2
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm
    ret

escribe_numero_3:
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level +8 ;; coordenada x
    ld b, #y_level ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_3
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm
    ret

escribe_numero_4:
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level +8 ;; coordenada x
    ld b, #y_level  ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_4
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm
    ret

escribe_numero_5:
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level +8 ;; coordenada x
    ld b, #y_level ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_5
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm
    ret

escribe_numero_6:
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level +8 ;; coordenada x
    ld b, #y_level ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_6
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm
    ret

escribe_numero_7:
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level  +8  ;; coordenada x
    ld b, #y_level;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_7
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm
    ret

escribe_numero_8:
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level +8 ;; coordenada x
    ld b, #y_level ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_8
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm
    ret

escribe_numero_9:
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level +8 ;; coordenada x
    ld b, #y_level  ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_9
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm
    ret

escribe_numero_0:
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level +8 ;; coordenada x
    ld b, #y_level  ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_0
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm
    ret

escribe_numero_10:

    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level  ;; coordenada x
    ld b, #y_level ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_1
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm
    ret

    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level + 8 ;; coordenada x
    ld b, #y_level ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_0
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm
    ret



;;Function to get actual level
select_level:

    cp #0x00
    jp nz, uno
    call escribe_numero_0

    uno:
    cp #0x01
    jp nz, dos
    call escribe_numero_1
    jp cero_delante

    dos:
    cp #0x02
    jp nz, tres
    call escribe_numero_2
    jp cero_delante

    tres:
    cp #0x03
    jp nz, cuatro
    call escribe_numero_3
    jp cero_delante

    cuatro:
    cp #0x04
    jp nz, cinco
    call escribe_numero_4
    jp cero_delante

    cinco:
    cp #0x05
    jp nz, seis
    call escribe_numero_5
    jp cero_delante

    seis:
    cp #0x06
    jp nz, siete
    call escribe_numero_6
    jp cero_delante

    siete:
    cp #0x07
    jp nz, ocho
    call escribe_numero_7
    jp cero_delante

    ocho:
    cp #0x08
    jp nz, nueve
    call escribe_numero_8
    jp cero_delante

    nueve:
    cp #0x09
    jp nz, diez
    call escribe_numero_9

    diez:
    call escribe_numero_10
    jp fin

    cero_delante:
    call escribe_primer_0

    fin:

    ret

;;Function to draw the level number into the interface
interface_draw_level::  
    push ix 
    push af
    push bc
    call get_num_actual_level
    call select_level
    pop bc
    pop af
    pop ix
    ret

clean_interface_score::
    ld ix, #_score
    ld iy, #_scoreIni

    ld a, (iy)
    ld (ix), a

    ld a, 1(iy)
    ld 1(ix), a
    
    ld a, 2(iy)
    ld 2(ix), a
    
    ld a, 3(iy)
    ld 3(ix), a

    ret
