    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
;;; 
;;; BULLET MANAGER
;;; 
;
.include "assets/entity.h.s"
.area _DATA
max_bullets_player = 4
max_bullets_enemy = 20

_array_bullets_player: .ds max_bullets_player*entity_size
_array_bullets_enemy: .ds max_bullets_enemy*entity_size

_last_bullet_player: .dw _array_bullets_player
_free_space_player: .dw _array_bullets_player
_num_bullets_player: .db 0

_last_bullet_enemy: .dw _array_bullets_enemy
_free_space_enemy: .dw _array_bullets_enemy
_num_bullets_enemy: .db 0

;_count_bullets_player: .db 5

b_x: .db 0
b_y: .db 0

bullet_player: Define_entity 0, 0, 1 ,2 , 0,-3, 0x0000, 1, 0
bullet_enemy: Define_entity 0, 0, 2 ,4 , 0,2, 0x0000, 1, 0
bullet_enemy_2_bullets: Define_entity 0, 0, 2 ,4 , 0, 3, 0x0000, 1, 0
bullet_enemy_bossT5: Define_entity 0, 0, 2 , 4 , 0, 3, 0x0000, 1, 0
bullet_enemy_laser: Define_entity 0, 0, 1 ,50 , 0,4, 0x0000, 1, 0
bullet_enemy_eyeBoss: Define_entity 0, 0, 1 ,50 , 0,8, 0x0000, 1, 0
;bullet_enemy_laser: Define_entity 0, 0, 1 ,50 , 0,4, 0x0000, 1, 0
bullet_sideman_preset: Define_entity 0, 0, 1 ,2 , 1 ,0, 0x0000, 1, 0
bullet_misil: Define_entity 35, 10, 4, 16, 0, 2, _misil, 1, 1
bullet_misil_p: Define_entity 0, 0, 2 , 16 , 0,3, _misil_p, 1, 0
bullet_misil_broken:: Define_entity 0, 180, 2 , 8 , -1, -2, _misil_broken, 1, 0
bullet_misil_broken2:: Define_entity 0, 180, 2 , 8 , 1, -2, _misil_broken2, 1, 0
bullet_misil_broken3:: Define_entity 0, 180, 2 , 8 , -1, 0, _misil_broken2, 1, 0
bullet_misil_broken4:: Define_entity 0, 180, 2 , 8 , 1, 0, _misil_broken2, 1, 0
bullet_smart_missile:: Define_entity 0, 0, 8 , 16 , 0, 2, _smart_missile, 5, 12
bullet_final_boss: Define_entity 0, 0, 2 , 16 , 0,3, _bullet_final_boss, 1, 0


;_cont_ret_player: .db 10
_cont_ret_enemy: .db 37
_cont_ret_boss: .db 11
_cont_ret_sideman: .db 29

_counter: .db 0

_auxIX: .dw 0x0000

.area _CODE 


;;Method to player shooting
;; INPUT
;; HL: POinter to initialitzer bytes
create_bullet_enemy::
    push ix
    push de
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl
    pop de
    pop ix
    ret

;;Method to player shooting
;; INPUT
;; IX: POinter to player
shootPlayer::
    
    ;ld a, (_cont_ret_player)
    ;dec a
    ;ld (_cont_ret_player), a
    ;ret nz
    ;ld a, #10
    ;ld (_cont_ret_player), a

    ld b, #max_bullets_player
    ld a, (_num_bullets_player)
    sub b
    ret nc


    ld a, 0(ix)
    add #0x01  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    add #0xF8  ;; Desplazamiento hacia arriba
    ld (b_y), a
    ld ix, #bullet_player
    call get_bullet_spaceship_sprite 
    ld 6(ix), l
    ld 7(ix) , h 
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld hl, #bullet_player
    ld de, (_last_bullet_player)

    ld ix, #_num_bullets_player
    call create_man_entities
    ld (_last_bullet_player), hl 

    
    ret
    
;; METHOD TO ENEMY SHOOTING 
;;  INPUT: 
;;     IX: Pointer to enemy 
shootEnemy::
    ld a, (_cont_ret_enemy)
    dec a
    ld (_cont_ret_enemy), a
    ret nz
    ;ld a, #37
    call get_next_random
    ld (_cont_ret_enemy), a

    ld b, #max_bullets_enemy
    ld a, (_num_bullets_enemy)
    sub b
    ret nc

    ld a, 0(ix)
    add #0x01  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    ld (b_y), a
    ld ix, #bullet_enemy
    call get_bullet_enemy_sprite 
    ld 6(ix) , l
    ld 7(ix) , h
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld hl, #bullet_enemy
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl 
    ret

 shootEnemy_laser::
    ld a, (_cont_ret_enemy)
    dec a
    ld (_cont_ret_enemy), a
    ret nz
    call get_next_random
    ld (_cont_ret_enemy), a
    ld b, #max_bullets_enemy
    ld a, (_num_bullets_enemy)
    sub b
    ret nc
    ld a, 0(ix)
    add #0x01  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    ld (b_y), a
    ld ix, #bullet_enemy_laser
    call get_bullet_enemy_laser_sprite 
    ld 6(ix) , l
    ld 7(ix) , h
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld hl, #bullet_enemy_laser
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl 
    ret

shootEnemy_eyeBoss::
    ld a, (_cont_ret_enemy)
    dec a
    ld (_cont_ret_enemy), a
    ret nz
    call get_next_random
    ld (_cont_ret_enemy), a
    ld b, #max_bullets_enemy
    ld a, (_num_bullets_enemy)
    sub b
    ret nc
    ld a, 0(ix)
    add #5  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    add #25
    ld (b_y), a
    ld ix, #bullet_enemy_eyeBoss
    call get_bullet_enemy_laser_sprite 
    ld 6(ix) , l
    ld 7(ix) , h
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld hl, #bullet_enemy_eyeBoss
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl 
    ret

shootEnemy_boss_spaceship_misil::
    ld a, (_cont_ret_enemy)
    dec a
    ld (_cont_ret_enemy), a
    ret nz
    call get_next_random
    ld (_cont_ret_enemy), a
    ld b, #max_bullets_enemy
    ld a, (_num_bullets_enemy)
    sub b
    ret nc
    ld a, 0(ix)
    add #5  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    add #25
    ld (b_y), a
    ld ix, #bullet_misil
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld hl, #bullet_misil
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl 
    ret


    shootEnemy_boss_spaceship_misil_p::
    ld a, (_cont_ret_enemy)
    dec a
    ld (_cont_ret_enemy), a
    ret nz
    call get_next_random
    ld (_cont_ret_enemy), a
    ld b, #max_bullets_enemy
    ld a, (_num_bullets_enemy)
    sub b
    ret nc
    ld a, 0(ix)
    add #10  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    add #20
    ld (b_y), a
    ld ix, #bullet_misil_p
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld hl, #bullet_misil_p
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl 
    ret

shootEnemy_spaceship_big::
    ld a, (_cont_ret_enemy)
    dec a
    ld (_cont_ret_enemy), a
    ret nz
    call get_next_random
    ld (_cont_ret_enemy), a
    ld b, #max_bullets_enemy
    ld a, (_num_bullets_enemy)
    sub b
    ret nc
    ld a, 0(ix)
    add #10  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    add #5
    ld (b_y), a
    ld ix, #bullet_final_boss
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld hl, #bullet_final_boss
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl 
    ret


shootEnemy_2_bullets::
    ld a, (_cont_ret_enemy)
    dec a
    ld (_cont_ret_enemy), a
    ret nz
    ;ld a, #37
    call get_next_random

    ld (_cont_ret_enemy), a

    ld b, #max_bullets_enemy
    ld a, (_num_bullets_enemy)
    inc a
    inc a
    sub b
    ret nc

    ld a, 0(ix)
    ld (_auxIX), ix
    add #0x04  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    ld (b_y), a
    ld ix, #bullet_enemy_2_bullets
    call get_bullet_enemy_sprite 
    ld 6(ix) , l
    ld 7(ix) , h
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld hl, #bullet_enemy_2_bullets
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl 

    ld ix, (_auxIX)
    ld a, 0(ix)
    add #0x00  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    ld (b_y), a
    ld ix, #bullet_enemy_2_bullets
    call get_bullet_enemy_sprite 
    ld 6(ix) , l
    ld 7(ix) , h
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld hl, #bullet_enemy_2_bullets
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl

    ret
shootsideman::

    ld a, (_cont_ret_sideman)
    dec a
    ld (_cont_ret_sideman), a
    ret nz
    call get_next_random
    ld (_cont_ret_sideman), a

    ld b, #max_bullets_enemy
    ld a, (_num_bullets_enemy)
    inc a
    inc a
    sub b
    ret nc

    ld a, 0(ix)
    ld (_auxIX), ix
    add #0x04  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    add #0x04 
    ld (b_y), a
    ld ix, #bullet_sideman_preset
    call get_bullet_sideman 
    ld 6(ix) , l
    ld 7(ix) , h
    ld a, (b_x)
    ld 0(ix) , a
    ld a, (b_y)
    ld 1(ix) , a
    ld a, #-2
    ld 4(ix) , a
    ld a, #0
    ld 5(ix) , a
    ld hl, #bullet_sideman_preset
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl 

    ld ix, (_auxIX)
    ld a, 0(ix)
    add #0x00  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    add #0x04 
    ld (b_y), a
    ld ix, #bullet_sideman_preset
    call get_bullet_sideman 
    ld 6(ix) , l
    ld 7(ix) , h
    ld a, (b_y)
    ld 1(ix) , a
    ld a, #2
    ld 4(ix) , a
    ld a, #0
    ld 5(ix) , a
    ld hl, #bullet_sideman_preset
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl


ret
shootBossT5::
    ld a, (_cont_ret_boss)
    dec a
    ld (_cont_ret_boss), a
    ret nz
    ;ld a, #11
    call get_next_random
    ld (_cont_ret_boss), a

    ld b, #max_bullets_enemy
    ld a, (_num_bullets_enemy)
    inc a
    inc a
    inc a
    inc a
    inc a
    inc a
    sub b
    ret nc

    ld a, 0(ix)
    ld (_auxIX), ix
    add #0x0C  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    add #0x04 
    ld (b_y), a
    ld ix, #bullet_enemy_bossT5
    call get_bullet_enemy_bossT5 
    ld 6(ix) , l
    ld 7(ix) , h
    ld a, (b_y)
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld a, #1
    ld 4(ix) , a
    ld a, #1
    ld 5(ix) , a
    ld hl, #bullet_enemy_bossT5
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl 
    
    ld ix, (_auxIX)
    ld a, 0(ix)
    add #0x0C  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    add #0x04 
    ld (b_y), a
    ld ix, #bullet_enemy_bossT5
    call get_bullet_enemy_bossT5 
    ld 6(ix) , l
    ld 7(ix) , h
    ld a, (b_y)
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld a, #0
    ld 4(ix) , a
    ld a, #1
    ld 5(ix) , a
    ld hl, #bullet_enemy_bossT5
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl

    ld ix, (_auxIX)
    ld a, 0(ix)
    add #0x0C  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    add #0x04 
    ld (b_y), a
    ld ix, #bullet_enemy_bossT5
    call get_bullet_enemy_bossT5 
    ld 6(ix) , l
    ld 7(ix) , h
    ld a, (b_y)
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld a, #1
    ld 4(ix) , a
    ld a, #2
    ld 5(ix) , a
    ld hl, #bullet_enemy_bossT5
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl 

    ld ix, (_auxIX)
    ld a, 0(ix)
    add #0x0B ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    add #0x04 
    ld (b_y), a
    ld ix, #bullet_enemy_bossT5
    call get_bullet_enemy_bossT5 
    ld 6(ix) , l
    ld 7(ix) , h
    ld a, (b_y)
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld a, #-1
    ld 4(ix) , a
    ld a, #1
    ld 5(ix) , a
    ld hl, #bullet_enemy_bossT5
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl 

    ld ix, (_auxIX)
    ld a, 0(ix)
    add #0x0A ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    add #0x04 
    ld (b_y), a
    ld ix, #bullet_enemy_bossT5
    call get_bullet_enemy_bossT5 
    ld 6(ix) , l
    ld 7(ix) , h
    ld a, (b_y)
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld a, #-1
    ld 4(ix) , a
    ld a, #2
    ld 5(ix) , a
    ld hl, #bullet_enemy_bossT5
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl 
    
    ld ix, (_auxIX)
    ld a, 0(ix)
    add #0x04  ;; Desplazamiento hacia la derecha
    ld (b_x), a
    ld a, 1(ix)
    add #0x0A
    ld (b_y), a
    ld ix, #bullet_enemy_bossT5
    call get_bullet_enemy_bossT5 
    ld 6(ix) , l
    ld 7(ix) , h
    ld a, (b_y)
    ld 1(ix) , a
    ld a, (b_x)
    ld 0(ix) , a
    ld a, #0
    ld 4(ix) , a
    ld a, #1
    ld 5(ix) , a
    ld hl, #bullet_enemy_bossT5
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call create_man_entities
    ld (_last_bullet_enemy), hl 
    

    ret




    
;;INPUT: IX -> POINTER TO ENTITY 
delete_man_bullet_player::
    ld (_free_space_player) , ix
    ld bc, (_free_space_player)
    ld de, (_last_bullet_player)
    ld ix, #_num_bullets_player
    call delete_man_entities
    ld (_last_bullet_player), hl

    ret
delete_man_bullet_enemy::

    ld (_free_space_enemy) , ix
    ld bc, (_free_space_enemy)
    ld de, (_last_bullet_enemy)
    ld ix, #_num_bullets_enemy
    call delete_man_entities
    ld (_last_bullet_enemy), hl

    ret
   
   

get_bullets_player_array::    
    ld ix, #_array_bullets_player
    ret

get_bullets_enemy_array::    
    ld ix, #_array_bullets_enemy
    ret

get_num_bullets_player_created:: 
    ld a, (_num_bullets_player)
    ret

get_num_bullets_enemy_created::
    ld a, (_num_bullets_enemy)
    ret

get_delete_bullet_player::
    ld hl, #delete_man_bullet_player
    ret

get_delete_bullet_enemy::
    ld hl, #delete_man_bullet_player
    ret

get_bullets_player_IY::
    ld iy, #_array_bullets_player
    ret


clean_bullets_player::
    ld a, #0
    ld (_num_bullets_player) , a
    ld hl, #_array_bullets_player
    ld (_last_bullet_player) , hl
    ld (_free_space_player), hl
    ret

clean_bullets_enemy::
   ld a, #0
   ld (_num_bullets_enemy) , a
   ld hl, #_array_bullets_enemy
   ld (_last_bullet_enemy) , hl
   ld (_free_space_enemy), hl
   ret


;; a - devuelve un numero random entre 15 y 64 
get_next_random::
    push bc
    push de 
    push hl
    ;; deja el random en L 
    call cpct_getRandom_mxor_u8_asm
    ld a, l
    srl a
    srl a
    srl a
    add #15
    pop hl
    pop de
    pop bc 
    ret