    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
;; 
;; ENEMIES MANAGER
;; 
.include "assets/entity.h.s"
.area _DATA
max_entities_enemy =  60

_num_enemies_created: .db #0x00

enemy_fields: Define_entity 1, 1, 5, 5 , 0,0, 0x0000, 3, 0

eye_son_1:: Define_entity 5, 10, 8, 36, 0, 12, _eye_boss_son, 10, 8
eye_son_2:: Define_entity 25, 10, 8, 36, 0, 8, _eye_boss_son, 10, 8
eye_son_3:: Define_entity 45, 10, 8, 36, 0, 12, _eye_boss_son, 10, 8

eye_son_4:: Define_entity 15, 10, 8, 36, 0, 12, _eye_boss_son, 10, 8
eye_son_5:: Define_entity 35, 10, 8, 36, 0, 12, _eye_boss_son, 10, 8


_array_enemies:
    .ds max_entities_enemy*entity_size
_last_enemy_ptr: .dw _array_enemies ;; Lo que hemos metido, es la direcci�n del array

_new_enemy_free_space: .dw _array_enemies

_pointer_initializer_enemies: .dw #0x00

_counter: .db 0

.area _CODE

;;Method to create entities
;; INPUT
;;    HL: Pointer to entity initializer bytes
create_man_enemies::
    push ix
    push de
    ld de, (_last_enemy_ptr)
    ld ix, #_num_enemies_created
    call create_man_entities
    ld (_last_enemy_ptr), hl 
    pop de
    pop ix
    ret 

;; Method to delete an entity with positions out of the screen
;; INPUT
;;  IX: Pointer to entity  bytes
delete_man_enemies::
    
    ld (_new_enemy_free_space) , ix
    ld bc, (_new_enemy_free_space)
    ld de, (_last_enemy_ptr)
    ld ix, #_num_enemies_created
    call delete_man_entities
    ld (_last_enemy_ptr), hl
    ret

get_enemies_array_position::    
    ld ix, #_array_enemies
    ret

get_enemies_created:: 
    ld a, (_num_enemies_created) 
    ret

get_max_enemies:: 
    ld a, #max_entities_enemy
    ret

get_enemies_array_position_IY::    
    ld iy, #_array_enemies
    ret

get_delete_enemy::
    ld hl, #delete_man_enemies
    ret

clean_enemies::
   ld a, #0
   ld (_num_enemies_created) , a
   ld hl, #_array_enemies
   ld (_last_enemy_ptr) , hl
   ld (_new_enemy_free_space), hl
   ret