    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------

.include "assets/entity.h.s"

.area _DATA


player: Define_entity 27, 150, 4 ,8 , 0,0, #0x0000, 3, 0
enemy: Define_entity 16, 5, 5 ,5 , 0, 1, #0x0000, 1, 0

_dir_copy: .dw 0
s_width = #0x48
s_height = #0xC8

_lives_restore: .db 3
_lives: .db 3 ;; Vida al comienzo del juego (después dependerá de la entidad de la nave)

_next_wave:: .db 0 ;; Lo utiliza interruptions para señalar cuando debe lanzarse una nueva oleada
_last_wave: .db 0

_cont_ret: .db 3
.area _CODE
managing_spaceship_entities::
   call interruptions_init
   call set_int_handler1

   ld a, (_lives_restore)
   ld (_lives), a
   call interface_init
  
   
   call rendersys_init
   call render_marco
   call interface_init

   call level_output ;;Showing the level number in game
   call init_levels
   call get_actual_level
   push de
   ld l, 3(ix)
   ld h, 4(ix)
   call set_music
   pop de 
   ld l, 0(ix)
   ld h, 1(ix)
   ld a, 2(ix) 
   
   ld (_dir_copy), hl
   ld ix, (_dir_copy)
   call level_entities_creator
   call get_actual_wave
   
   ld l, 0(ix)
   ld h, 1(ix)

   ld de, #entities_init
   jp (hl)

   
   entities_init:
      call get_max_spaceships ;; Getting the max entities in the a register 
      ;;Getting the sprite 
      call get_spaceship_sprite

      entities: 
      
         push af
         ld ix, #player
         call get_spaceship_sprite
         ld 6(ix), l
         ld 7(ix) , h
         ld hl, #player
         call create_man_spaceships
         pop af
         dec a 
         jr nz, entities

    
         call get_spaceship_array_position
         ld a, (_lives)
         ld e_lives(ix), a

         call interface_render_lives
         
   jp loop

spaceship_loop: 
   
   call get_spaceship_array_position ;;Cargamos en ix la posici�n del array
   call get_spaceships_created ;; Cargamos el n�mero de entidades que tenemos creadas
   call sys_update_position_spaceship;; Movemos las posiciones 
   call get_spaceship_array_position ;;Cargamos en ix la posici�n del array
   call sys_input_update_spaceship
   ret

wave_loop:
   ld a, #0
   ld (_next_wave), a
   ld (_last_wave), a

   call get_num_waves_created
   cp #0x00
   jp z, level_loop
   call get_actual_wave
   call delete_man_waves
   call get_num_waves_created
   cp #0x00
   jp z, level_loop
   call get_actual_wave
   ld l, 0(ix)
   ld h, 1(ix)
   ld de, #loop
   jp (hl)

level_loop:

   call clean_items
   
   call get_spaceship_array_position
   ld a, e_lives(ix)
   ld (_lives), a

   call get_actual_level
   call delete_man_levels
   call get_num_levels_created
   cp #0x00
   jp z, victory
   call level_output ;;Showing the level number in game
   call get_actual_level
   ;;Setting the music for the level 
   push de
   ld l, 3(ix)
   ld h, 4(ix)
   call set_music
   pop de 
   ld l, 0(ix)
   ld h, 1(ix)
   ld a, 2(ix) 
   ld (_dir_copy), hl
   ld ix, (_dir_copy)
   call level_entities_creator
   call get_actual_wave
   ld l, 0(ix)
   ld h, 1(ix)
   ld de, #entities_init
   ld de, #loop
   jp (hl) 



enemies_loop:
   ld a, (_last_wave)
   cp #0x00
   jp z, not_last

   call get_enemies_array_position ;;Cargamos en ix la posici�n del array
   call get_enemies_created ;; Cargamos el n�mero de entidades que tenemos creadas
   cp #0x00
   jp z, wave_loop

   not_last:
  
   call get_enemies_array_position ;;Cargamos en ix la posici�n del array
   call get_enemies_created ;; Cargamos el n�mero de entidades que tenemos creadas
   call sys_update_position_enemy;; Movemos las posiciones 
   
   call get_enemies_array_position
   call get_enemies_created 
   call sys_input_enemy_loop
   ret

items_loop:
   
   call get_items_array_position
   call get_items_created
   call rendersys_update_item ;;Lo cargamos en pantalla
   
   call get_items_array_position ;;Cargamos en ix la posici�n del array
   call get_items_created ;; Cargamos el n�mero de entidades que tenemos creadas
   call sys_update_position_item;; Movemos las posiciones 
   ret

bullet_player_loop: 
   
   call get_bullets_player_array
   call get_num_bullets_player_created
   call sys_update_position_bullet_player
   ret

bullet_enemy_loop:
   
   call get_bullets_enemy_array
   call get_num_bullets_enemy_created
   call sys_update_position_bullet_enemy

   call get_bullets_enemy_array
   call get_num_bullets_enemy_created
   call sys_input_bullet_loop
   ret

bullets_loop:
   call bullet_player_loop
   call bullet_enemy_loop
   ret

collisions_loop:
   ;; BULLETS PLAYER
   call get_enemies_created ;; B
   ld b, a   
   call get_bullets_player_array ;; IX
   call get_num_bullets_player_created ;;A
   call get_enemies_array_position_IY ;; IY
   call get_collision_bullet_player ;; HL
   call check_collisions


   ;;BULLETS ENEMY
   call get_spaceships_created ;; B
   ld b, a   
   call get_bullets_enemy_array ;; IX
   call get_num_bullets_enemy_created ;;A
   call get_spaceship_array_position_IY ;; IY
   call get_collision_bullet_enemy ;; HL
   call check_collisions

   ;;ENEMY SHIPS
   call get_enemies_created ;; B
   ld b, a   
   call get_spaceship_array_position ;; IX
   call get_spaceships_created ;;A
   call get_enemies_array_position_IY ;; IY
   call get_collision_enemy_player ;; HL
   call check_collisions

   ;;ITEMS
   call get_items_created ;; B
   ld b, a   
   call get_spaceship_array_position ;; IX
   call get_spaceships_created ;;A
   call get_items_array_position_IY ;; IY
   call get_collision_item ;; HL
   call check_collisions
   ret


interface_loop:
   ;call interface_render_lives
   ret

loop:
   ld a, (_cont_ret)
   dec a
   ld (_cont_ret), a
   jr z, toloop
   jr not_loop
   toloop: 
   ld a, #3
   ld (_cont_ret), a
   call enemies_loop
   call items_loop

   
  
   not_loop:
   call bullets_loop
   call collisions_loop
   call spaceship_loop
   ;call items_loop
   call interface_loop


   ld a, (_next_wave)
   cp #0x00
   call nz, wave_loop
   
   
   ;halt
   ;halt
   
   call cpct_waitVSYNC_asm
   call render_loop
   jr loop




;create_enemy_again:: 
   ;push af
   ;ld ix, #enemy
   ;call get_enemy_sprite 
   ;ld 6(ix), l
   ;ld 7(ix), h
   
   ;ld hl, #enemy
   ;pop af
   ;call create_man_enemies
   
   ;ret




get_loop_game::
   ld hl, #loop
   ret

last_wave::
   ld a, #1
   ld (_last_wave), a
   ret

   render_loop: 
   call get_spaceship_array_position ;;Cargamos en ix la posiciï¿½n del array
   call get_spaceships_created ;; Cargamos el nï¿½mero de entidades que tenemos creadas
   call rendersys_update_spaceship ;;Lo cargamos en pantalla 

   call get_enemies_array_position ;;Cargamos en ix la posiciï¿½n del array
   call get_enemies_created ;; Cargamos el nï¿½mero de entidades que tenemos creadas
   call rendersys_update_enemy ;;Lo cargamos en pantalla


   call get_bullets_player_array
   call get_num_bullets_player_created
   call rendersys_update_bullet

   call get_bullets_enemy_array
   call get_num_bullets_enemy_created
   call rendersys_update_bullet
   
   ret
