    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
;; 
;; ITEMS MANAGER
;; 
.include "assets/entity.h.s"
.area _DATA
max_entities_item =  1

_num_items_created: .db #0x00

;item_fields: Define_entity 1, 1, 5, 5 , 0,0, 0x0000, 3

_array_items:
    .ds max_entities_item*entity_size

_last_item_ptr: .dw _array_items ;; Lo que hemos metido, es la direcci�n del array

_new_item_free_space: .dw _array_items

_pointer_initializer_items: .dw #0x00

_counter: .db 0

.area _CODE
;;Method to create entities
;; INPUT
;;    HL: Pointer to entity initializer bytes
create_man_items::

    ld b, #max_entities_item
    ld a, (_num_items_created)
    sub b
    ret nc

    ld de, (_last_item_ptr)
    ld ix, #_num_items_created
    call create_man_entities
    ld (_last_item_ptr), hl 
    ret

;; Method to delete an entity with positions out of the screen
;; INPUT
;;  IX: Pointer to entity  bytes
delete_man_items::
    
    ld (_new_item_free_space) , ix
    ld bc, (_new_item_free_space)
    ld de, (_last_item_ptr)
    ld ix, #_num_items_created
    call delete_man_entities
    ld (_last_item_ptr), hl
    ret

get_items_array_position::    
    ld ix, #_array_items
    ret

get_items_created:: 
    ld a, (_num_items_created) 
    ret

get_max_items:: 
    ld a, #max_entities_item
    ret

get_items_array_position_IY::    
    ld iy, #_array_items
    ret

get_delete_item::
    ld hl, #delete_man_items
    ret

clean_items::
   ld a, #0
   ld (_num_items_created) , a
   ld hl, #_array_items
   ld (_last_item_ptr) , hl
   ld (_new_item_free_space), hl
   ret

sys_update_position_item:: 
    call get_item_error_x
    call get_item_error_y
    call sys_update_position_entities
    ret

rendersys_update_item:: 
    call rendersys_update
    ret