    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
;; 
;; Manager for level entities ;; Each level is composed by multiple set levels 
;; 

.include "assets/entity.h.s"

.area _DATA

max_levels = 6
_num_levels_created: .db 0
_actual_level_number: .db 1
_actual_level_phase: .db 0
_array_levels: 
    .ds max_levels*entity_size
_last_lvl_ptr: .dw _array_levels
_new_free_space: .dw _array_levels

_counter_level_initializer:   .db 0


.area _CODE


;;Function to init the levels
init_levels::

    call get_opcion
    cp #0x00
    jp z, normal_mode
    call get_opcion
    cp #0x01
    jp z, hard_mode
    call get_opcion
    cp #0x02
    jp z, boss_mode
    
    normal_mode:
    call get_level6
    call create_man_levels
    call get_level5
    call create_man_levels
    call get_level4
    call create_man_levels
    call get_level3
    call create_man_levels
    call get_level2
    call create_man_levels
    call get_level1
    call create_man_levels
    ret

    hard_mode:

   
    call get_level_HM_6
    call create_man_levels
    call get_level_HM_5
    call create_man_levels
    call get_level_HM_4
    call create_man_levels
    call get_level_HM_3
    call create_man_levels
    call get_level_HM_2
    call create_man_levels
    call get_level_HM_1
    call create_man_levels
    ret

    boss_mode:
    call get_level_BM_5
    call create_man_levels
    call get_level_BM_4
    call create_man_levels
    call get_level_BM_3
    call create_man_levels
    call get_level_BM_2
    call create_man_levels
    call get_level_BM_1
    call create_man_levels

    ret



create_man_levels::
    push de 
    push ix
    ld de, (_last_lvl_ptr)
    ld ix, #_num_levels_created
    call create_man_entities
    ld (_last_lvl_ptr), hl 
    pop ix
    pop de 
    ret 

delete_man_levels::
    push af
    ld a, (_actual_level_number)
    inc a
    ld (_actual_level_number), a
    sbc a, #10
    jr z, level_greater

    delete:
    pop af
    push ix 
    ld (_new_free_space) , ix
    ld bc, (_new_free_space)
    ld de, (_last_lvl_ptr)
    ld ix, #_num_levels_created
    call delete_man_entities_levels
    ld (_last_lvl_ptr), hl
    ld (_new_free_space) , hl
    pop ix
    ret

clean_levels:: 
    ld a, #0
    ld (_num_levels_created) , a
    ld (_actual_level_phase), a
    inc a
    ld (_actual_level_number) , a
    ld hl, #_array_levels
    ld (_last_lvl_ptr) , hl
    ld (_new_free_space),hl 
    ret

level_greater: 
    ld a, (_actual_level_phase)
    inc a
    ld (_actual_level_phase), a
    ld a, #0
    ld (_actual_level_number), a
    jp delete

;; INPUT: 
;;  A - N�mero de oleadas a crear 
;;  IX - Array of waves

level_entities_creator:: 
    
    wave_creator: 
        ld (_counter_level_initializer), a
        cp #0x00
        ret z
        
        ld l, 0(ix)
        ld h, 1(ix)
        push ix 
        call create_man_waves
        pop ix
        ld bc, #2
        add ix, bc
        ld a, (_counter_level_initializer)
        dec a 
        jr nz, wave_creator
    ret 


;;Function to get the actual level
get_actual_level:: 
    ;push hl 
    ;push de 
    ld hl, (_last_lvl_ptr)
    ld de, #entity_size
    sbc hl, de
    ld (_new_free_space) ,hl
    ld ix, (_new_free_space)
    ;pop de
    ;pop hl 
    ret

;;Function to get the array
get_level_array_position:: 
    ld ix, #_array_levels
    ret

get_num_levels_created:: 
    ld a, (_num_levels_created) 
    ret

get_num_actual_level::
    ld a, (_actual_level_number)
    ret

get_num_actual_phase:: 
    ld a, (_actual_level_phase)
    ret