    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
;; 
;; SPACESHIP MANAGER
;; 
.include "assets/entity.h.s"

.area _DATA
max_entities_spaceship = 1

_num_spaceships_created: .db 0
;;En este caso, no vamos a tener un array, dado que el n�mero de entidades de jugador, ser� solamente de una entidad
_array_spaceships:
    .ds max_entities_spaceship*entity_size
_last_elem_ptr: .dw _array_spaceships ;;Lo que hemos metido, es la direcci�n del array

_new_free_space: .dw _array_spaceships

_counter: .db 0

.area _CODE 
;; Calling to the new method of creating entities
;;OUTPUT 
create_man_spaceships:: 

    ld de, (_last_elem_ptr)
    ld ix, #_num_spaceships_created
    call create_man_entities

    ld (_last_elem_ptr), hl 

    ret 

delete_man_spaceships: 
    ld (_new_free_space) , ix
    ld bc, (_new_free_space)
    ld de, (_last_elem_ptr)
    ld ix, #_num_spaceships_created
    call delete_man_entities
    ld (_last_elem_ptr), hl
    ret
get_spaceship_array_position::    
    ld ix, #_array_spaceships
    ret

get_spaceships_created:: 
    ld a, (_num_spaceships_created) 
    ret

get_max_spaceships:: 
    ld a, #max_entities_spaceship
    ret

get_spaceship_array_position_IY::
    ld iy, #_array_spaceships
    ret

get_delete_spaceship::
    ld hl, #delete_man_spaceships
    ret

clean_spaceship::
    ld a, #0
    ld (_num_spaceships_created) , a
    ld hl, #_array_spaceships
    ld (_last_elem_ptr) ,hl
    ld (_new_free_space),  hl
    ret