    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
;;
;; wave MANAGER
;; 
.include "assets/entity.h.s"

.area _DATA

max_waves = 20
_num_waves_created: .db 0
_array_waves: 
    .ds max_waves*entity_size
_last_wv_ptr: .dw _array_waves
_new_free_space: .dw _array_waves


_AuxVariable:               .dw 0
_counterwaveInitializer:   .db 0
retAddr:                    .dw 0 

_aux1: .db 0
_aux2: .db 0
_auxIY: .dw #0x0000 

.area _CODE
;;Function to init the waves

create_man_waves::
    push de
    push ix
    ld de, (_last_wv_ptr)
    ld ix, #_num_waves_created
    call create_man_entities
    ld (_last_wv_ptr), hl 
    pop ix 
    pop de
    
    ret 

delete_man_waves::
    push ix
    ld (_new_free_space) , ix
    ld bc, (_new_free_space)
    ld de, (_last_wv_ptr)
    ld ix, #_num_waves_created
    call delete_man_entities_levels
    ld (_last_wv_ptr), hl
    pop ix
    ret


clean_waves:: 
    ld a, #0
    ld (_num_waves_created) , a
    ld hl, #_array_waves
    ld (_last_wv_ptr) , hl
    ld (_new_free_space),hl 
    ret




;;Function to get the actual wave
get_actual_wave::

    ld hl, (_last_wv_ptr)
    ld de, #entity_size
    sbc hl , de
    ld (_new_free_space), hl
    ld ix, (_new_free_space)
    ret

;;Function to get the array
get_wave_array_position::
    ld ix, #_array_waves
    ret

get_num_waves_created:: 
    ld a, (_num_waves_created)
    ret




    ;; Necesita: 
    ;;  DE - Direccion de vuelta
    ;;  IX - Puntero a vector origen de enemigos
    ;;  A  - Numero de enemigos de la oleada
    ;;  IY - Puntero a vector de items
    ;;  B  - Numero de items de la oleada

wave_entities_creator::
    ld (retAddr), de
    ld (_aux1), a
    ld a, b
    ld (_aux2), a
    ld (_auxIY), iy
    
    ld a, (_aux1)
    enemy_creator: 
        ld (_counterwaveInitializer), a
        cp #0x00
        jp z , emergency_exit

        ;SPRITE
        ;---------------------
        ;type defult
        ld a, e_type(ix)
        cp #0x00
        jp nz, type_2_bullets
        call get_enemy0_sprite
        jp next1

        ; type_laser:
        ; cp #0x01
        ; jp nz, type_2_bullets
        ; call get_enemy_zygon1
        ; jp next1

        type_2_bullets:
        cp #0x01
        jp nz, type_not_shoot
        call get_enemy1_sprite
        jp next1

        type_not_shoot: 
            cp #0x03
            jp nz, type_red
            call get_enemy_zygon1
            jp next1
        
        type_red:
            cp #0x04
            jp nz, type_boss1
            call get_enemy_sprite_red
            jp next1

        type_boss1: 
            cp #0x05
            jp nz, type_son
            call get_enemy_sprite_boss1
            jp next1

        type_son: 
            cp #0x06
            jp nz, type_eye_boss
            call get_enemySon_sprite
            jp next1 

        type_eye_boss:
            cp #0x07
            jp nz, type_eye_son
            call get_enemyEyeBoss_sprite
            jp next1
        
        type_eye_son:
            cp #0x08
            jp nz, type_SideMan
            call get_enemyEyeBoss_son_sprite
            jp next1
        type_SideMan:
            cp #0x09
            jp nz, type_boss_spaceship
            call get_enemySideMan_sprite
            jp next1

        type_boss_spaceship:
            cp #10
            jp nz, type_spaceship_big
            call get_enemy_boss_spaceship_sprite
            jp next1

        type_spaceship_big:
            cp #11
            jp nz, next1
            call get_spaceship_big_sprite
            jp next1

        next1:

        ;---------------------
        
        ld 6(ix), l
        ld 7(ix), h
        
        ld (_AuxVariable), ix 
        ld hl, (_AuxVariable)
        
        call create_man_enemies
        ld bc, #entity_size
        add ix, bc
        ld a, (_counterwaveInitializer)
        dec a 
        jp nz, enemy_creator

    ld iy, (_auxIY)
    ld a, (_aux2)
    items_creator: 
        ld (_counterwaveInitializer), a
        cp #0x00
        jp z , emergency_exit

        ;SPRITE
        ;---------------------
        ;type_medical_kit
        ld a, e_type(ix)
        cp #0x00
        jp nz, type_bullets
        call get_item_medical_kit
        jp next2

        type_bullets:
        cp #0x01
        jp nz, type_hourglass
        call get_item_bullet
        jp next2
        
        type_hourglass:
        cp #0x02
        jp nz, next2
        call get_item_hourglass
        
        next2:

        ;---------------------
        ;  ?????????????????????????
        ld 6(iy), l
        ld 7(iy), h
                
        ld (_AuxVariable), iy
        ld hl, (_AuxVariable)
        
        call create_man_items
        ld bc, #entity_size
        add iy, bc
        ld a, (_counterwaveInitializer)
        dec a 
        jp nz, items_creator

    emergency_exit: 
    ld hl , (retAddr) 
    
    jp (hl)

