    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
    
;; Include all CPCtelera constant definitions, macros and variables

.include "cpctelera.h.s"
.area _DATA 
.globl cpct_getScreenPtr_asm
.globl cpct_setDrawCharM1_asm
.globl cpct_drawStringM1_asm
.globl cpct_scanKeyboard_f_asm
.globl cpct_drawSolidBox_asm

opcion: .db 0x00

palette: 
    .db HW_BLACK, HW_BRIGHT_WHITE, HW_BLUE, HW_RED

_counter_marco: .db 0
_aux: .db 0
_max_x_marco = 10
_max_y_marco = 24
_y: .db 0
_x: .db 0
_ancho: .db 0
_alto: .db 0

;;KEYS
;Key_O = #0x0404
;Key_P = #0x0803
;Key_Q = #0x0808
;Key_A = #0x2008

;;SCORE
_score_d1:: .db 0
_score_d2:: .db 0
_score_d3:: .db 0

;;MENU
;;*******************************************************
realbacon: .asciz " REAL BACON STUDIOS "
x_realbacon = 20
y_realbacon = 0

stringTitulo: .asciz "    OVNI SAMURAI    "
x_titulo = 20
y_titulo = 34

x_cuadroTitulo = 17
y_cuadroTitulo = 30
ancho_cuadroTitulo = 46
alto_cuadroTitulo = 15
color_cuadroTitulo = #0xFF

x_cuadroTitulo2 = 16
y_cuadroTitulo2 = 26
ancho_cuadroTitulo2 = 48
alto_cuadroTitulo2 = 23
color_cuadroTitulo2 = #0xF0

string_level: .asciz "Level   " ;;8 B
x_level = 4
y_level = 20

;;Patalla controles
string_tituloControles: .asciz "CONTROLS"
x_tituloControles = 32
y_tituloControles = 34

stringInstruccionControles: .asciz "Press SPACE to return"
x_instruccionControles = 19
y_instruccionControles = 170

string_teclaSpace: .asciz "SPACE    ->    SHOOT"
string_teclaUp: .asciz "  Q      ->    UP"
string_teclaDown: .asciz "  A      ->    DOWN"
string_teclaRight: .asciz "  P      ->    RIGHT"
string_teclaLeft: .asciz "  O      ->    LEFT"
string_teclaEsc: .asciz " ESC     ->    PAUSE"

x_tecla = 20
y_teclaSpace = 70
y_teclaUp = 80
y_teclaDown = 90
y_teclaRight = 100
y_teclaLeft = 110
y_teclaEsc = 120



;;Strings---------------------
stringComenzar: .asciz " PLAY GAME " 
stringControles: .asciz " CONTROLS "
stringHardMode: .asciz " HARD MODE " 
stringBossMode: .asciz " BOSS MODE "
stringInstruccion1: .asciz "Press SPACE to navigate"
stringInstruccion2: .asciz "Press ENTER to select"

;;Posicion Strings
x_comenzar = 29
y_comenzar = 73

x_hard_mode = 29
y_hard_mode = 88

x_boss_mode = 29
y_boss_mode = 103

x_controles = 30
y_controles = 118

x_instruccion1 = 17
y_instruccion1 = 155

x_instruccion2 = 19
y_instruccion2 = 170

;;Color Strings
color_letra = 1
color_fondo_letra = 2
color_resaltado_letra = 3

;;-----------------------------

;;Cuadros----------------------

;;Cuador Exterior (marco)
x_cuadroExt = 14
y_cuadroExt = 61
ancho_cuadroExt = 52
alto_cuadroExt = 78
color_cuadroExt = #0xF0

;;Cuadro Interio
x_cuadroInt = 15
y_cuadroInt = 65
ancho_cuadroInt = 50
alto_cuadroInt = 70
color_cuadroInt = #0x0F

;;Cuadrado para borrar el menu
x_cuadroBorrar = 13
y_cuadroBorrar = 30
ancho_cuadroBorrar = 54
alto_cuadroBorrar = 160
color_cuadroBorrar = 0x00

;;-----------------------------------
;;*******************************************************


;;PAUSE
;;*****************************************************

;;Strings------------------
stringPause: .asciz "  PAUSE  "
stringInstruccionPause: .asciz "Press SPACE to CONTINUE"
stringSalirPause: .asciz "Prees ENTER to EXIT"

;;Posicion strings
x_pause = 31
y_pause = 34

x_instruccion_pause = 17
y_instruccion_pause = 85

x_salir_pause = 20
y_salir_pause = 105

;;********************************************************


;;GAME OVER
;;********************************************************

;;Strings-------------------
stringGameOver: .asciz "GAME OVER"

x_game_over = 31
y_game_over = 34

;;********************************************************

;;VICTORY
;;********************************************************

;;Strings-------------------
string_youWin: .asciz "YOU WIN"
stringScore: .asciz "YOUR SCORE:    0" ;16

x_youWin = 33
y_youWin = 34

x_score = 24
y_score = 90


.area _CODE

;;********************************************************



menu_init::

    ld c , #1
    call cpct_setVideoMode_asm

    ;;Border 13, SET_PALETTE
    cpctm_setBorder_asm HW_BLACK
    ld hl, #palette 
    ld de , #16
    call cpct_setPalette_asm 

    call clean_screen

    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_cuadroTitulo2 ;; coordenada x
    ld b, #y_cuadroTitulo2 ;; coordenada y
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    ld a, #color_cuadroTitulo2 ;; Color del cuadro
    ld c, #ancho_cuadroTitulo2 ;;ancho
    ld b, #alto_cuadroTitulo2 ;;alto
    call cpct_drawSolidBox_asm


    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_cuadroTitulo ;; coordenada x
    ld b, #y_cuadroTitulo ;; coordenada y
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    ld a, #color_cuadroTitulo ;; Color del cuadro
    ld c, #ancho_cuadroTitulo ;;ancho
    ld b, #alto_cuadroTitulo ;;alto
    call cpct_drawSolidBox_asm


    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_cuadroExt ;; coordenada x
    ld b, #y_cuadroExt ;; coordenada y
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    ld a, #color_cuadroExt ;; Color del cuadro
    ld c, #ancho_cuadroExt ;;ancho
    ld b, #alto_cuadroExt ;;alto
    call cpct_drawSolidBox_asm

    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_cuadroInt ;; coordenada x
    ld b, #y_cuadroInt ;; coordenada y
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    ld a, #color_cuadroInt ;; Color del cuadro
    ld c, #ancho_cuadroInt ;;ancho
    ld b, #alto_cuadroInt ;;alto
    call cpct_drawSolidBox_asm

    push de
    push hl
    ld hl, #_song_level_1_2
    call set_music
    pop hl
    pop de
    
    ret

menu::
    
    

    call keys

    ;;Titulo
    ld a, #3
    ld e, #color_letra
    ld iy, #stringTitulo
    ld b, #y_titulo ;;y
    ld c, #x_titulo ;; x
    call escribir



    ;; Volvemos a escribir el seleccionado, pero resaltado

    ld a, (opcion)
    cp #0x00
    jp z, seleccionadoComenzar
    ld a, (opcion)
    cp #0x01
    jp z, seleccionadoHardMode
    ld a, (opcion)
    cp #0x02
    jp z, seleccionadoBossMode
    ld a, (opcion)
    cp #0x03
    jp z, seleccionadoControls


    ;;COMENZAR aparece seleccionado
    seleccionadoComenzar:
    ld a, #color_resaltado_letra
    ld e, #color_letra
    ld iy, #stringComenzar
    ld b, #y_comenzar ;;y
    ld c, #x_comenzar ;; x
    call escribir
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringHardMode
    ld b, #y_hard_mode ;;y
    ld c, #x_hard_mode ;; x
    call escribir
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringBossMode
    ld b, #y_boss_mode ;;y
    ld c, #x_boss_mode ;; x
    call escribir
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringControles
    ld b, #y_controles ;;y
    ld c, #x_controles ;; x
    call escribir
    jp finMenu

    ;;Controls aparece seleccionado
    seleccionadoControls:
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringComenzar
    ld b, #y_comenzar ;;y
    ld c, #x_comenzar ;; x
    call escribir
    ld a, #color_resaltado_letra
    ld e, #color_letra
    ld iy, #stringControles
    ld b, #y_controles ;;y
    ld c, #x_controles ;; x
    call escribir
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringHardMode
    ld b, #y_hard_mode ;;y
    ld c, #x_hard_mode ;; x
    call escribir
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringBossMode
    ld b, #y_boss_mode ;;y
    ld c, #x_boss_mode ;; x
    call escribir
    jp finMenu

    ;;Controls aparece seleccionado
    seleccionadoHardMode:
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringComenzar
    ld b, #y_comenzar ;;y
    ld c, #x_comenzar ;; x
    call escribir
    ld a, #color_resaltado_letra
    ld e, #color_letra
    ld iy, #stringHardMode
    ld b, #y_hard_mode ;;y
    ld c, #x_hard_mode ;; x
    call escribir
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringBossMode
    ld b, #y_boss_mode ;;y
    ld c, #x_boss_mode ;; x
    call escribir
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringControles
    ld b, #y_controles ;;y
    ld c, #x_controles ;; x
    call escribir
    jp finMenu
    
    ;;Controls aparece seleccionado
    seleccionadoBossMode:
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringComenzar
    ld b, #y_comenzar ;;y
    ld c, #x_comenzar ;; x
    call escribir
    ld a, #color_resaltado_letra
    ld e, #color_letra
    ld iy, #stringBossMode
    ld b, #y_boss_mode ;;y
    ld c, #x_boss_mode ;; x
    call escribir
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringHardMode
    ld b, #y_hard_mode ;;y
    ld c, #x_hard_mode ;; x
    call escribir
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringControles
    ld b, #y_controles ;;y
    ld c, #x_controles ;; x
    call escribir
    jp finMenu
    
    

    finMenu:
    ld a, #0x00
    ld e, #color_letra
    ld iy, #stringInstruccion1
    ld b, #y_instruccion1 ;;y
    ld c, #x_instruccion1 ;; x
    call escribir

    ld a, #0x00
    ld e, #color_letra
    ld iy, #stringInstruccion2
    ld b, #y_instruccion2 ;;y
    ld c, #x_instruccion2 ;; x
    call escribir

    ld a, #2
    ld e, #color_letra
    ld iy, #realbacon
    ld b, #y_realbacon ;;y
    ld c, #x_realbacon ;; x
    call escribir
    
    jp menu

get_opcion::
    ld a, (opcion)
    ret

;;INPUT
;;      A: color del fondo
;;      E: color de letra 
;;      B: coordenada y
;;      C: coordenada x
;;     IY: puntero al string
escribir:
    push bc

    ;ld    e, #color_letra         ;; E = Foreground PEN (3)
    ld    d, a                    ;; D = Background PEN (0)
    call cpct_setDrawCharM1_asm   ;; Set draw char colours

    ;; Calculate a video-memory location for printing a string
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    pop bc
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL    
     
    call cpct_drawStringM1_asm  ;; Draw the string 
    ret

;escribir_pause:
;    push bc
;
;    ld    e, #5        ;; E = Foreground PEN (3)
;    ld    d, #3                    ;; D = Background PEN (0)
;    call cpct_setDrawCharM0_asm   ;; Set draw char colours
;
;    ;; Calculate a video-memory location for printing a string
;    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
;    pop bc
;    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL    
;     
;    call cpct_drawStringM0_asm  ;; Draw the string 


keys:
    call cpct_scanKeyboard_f_asm

    ld hl , #Key_Space
    call cpct_isKeyPressed_asm
    jr z, Space_NotPressed
    
    ;;If it's pressed
    ld a, (opcion)
    cp #0x03
    jp z, opcion_3
    ld a, (opcion)
    inc a
    ld (opcion), a
    call little_wait
    ret

    opcion_3:
    ld a, #0
    ld (opcion), a
    call little_wait
    ret


    Space_NotPressed:

    ld hl, #Key_Return
    call cpct_isKeyPressed_asm
    ret z
    ld a, (opcion)
    cp #0x03
    jp z, pantalla_controles
    call clean_screen
    call clean_score
    jp game


keys_pause:
    call cpct_scanKeyboard_f_asm

    ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    jp z, Space_NotPressed_pause
    call little_wait
    call little_wait
    call clean_screen
    jp return_game

    Space_NotPressed_pause:
    ld hl, #Key_Return
    call cpct_isKeyPressed_asm
    ret z
    call clean
    call little_wait

    call menu_init
    
    jp menu



keys_controles:
    call cpct_scanKeyboard_f_asm

    ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    ret z
    call clean_screen
    call menu_init
    jp menu


clean_menu:
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_cuadroBorrar ;; coordenada x
    ld b, #y_cuadroBorrar ;; coordenada y
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    ld a, #color_cuadroBorrar ;; Color del cuadro
    ld c, #ancho_cuadroBorrar ;;ancho
    ld b, #alto_cuadroBorrar ;;alto
    call cpct_drawSolidBox_asm
    ret
clean_score:
    ld a, #0
    ld (_score_d1) ,a
    ld (_score_d2) , a
    ld (_score_d3) , a
    ret

pantalla_controles:
    call clean_screen 
    call menu_init
    
    ;; Controles
    ld a, #color_resaltado_letra
    ld e, #color_letra
    ld iy, #string_tituloControles
    ld b, #y_tituloControles ;;y
    ld c, #x_tituloControles ;; x
    call escribir

    ;; Instruccion salir de controles
    ld a, #0
    ld e, #color_letra
    ld iy, #stringInstruccionControles
    ld b, #y_instruccionControles ;;y
    ld c, #x_instruccionControles ;; x
    call escribir

    ;; Tecla SPACE
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #string_teclaSpace
    ld b, #y_teclaSpace ;;y
    ld c, #x_tecla ;; x
    call escribir

    ;; Tecla UP
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #string_teclaUp
    ld b, #y_teclaUp ;;y
    ld c, #x_tecla ;; x
    call escribir

    ;; Tecla Down
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #string_teclaDown
    ld b, #y_teclaDown ;;y
    ld c, #x_tecla ;; x
    call escribir

    ;; Tecla Right
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #string_teclaRight
    ld b, #y_teclaRight ;;y
    ld c, #x_tecla ;; x
    call escribir

    ;; Tecla Left
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #string_teclaLeft
    ld b, #y_teclaLeft ;;y
    ld c, #x_tecla ;; x
    call escribir

    ;; Tecla ESC
    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #string_teclaEsc
    ld b, #y_teclaEsc ;;y
    ld c, #x_tecla ;; x
    call escribir

    loop_controles:
    call keys_controles
    jp loop_controles
    
    ret

inc_score_d3: 
    ld a, (_score_d3)
    inc a
    ld (_score_d3) , a
    ld a, #0
    ld (_score_d2), a
    ld (_score_d1), a
    call interface_draw_score
    ret

inc_score_d2:
    ld a, (_score_d2)
    inc a
    ld (_score_d2) , a
    sbc a, #10
    jr z, inc_score_d3
    ld a, #0 
    ld (_score_d1), a
    call interface_draw_score
    ret 

inc_score:: 
    ld a, (_score_d1)
    inc a
    ld (_score_d1), a
    sbc a, #10
    jr z, inc_score_d2
    call interface_draw_score
    ret



draw_score:
;; SCORE
    ld ix, #stringScore
    ld a, (_score_d1)
    add a, #0x30
    ld 15(ix), a
    ld a, (_score_d2)
    add a, #0x30
    ld 14(ix), a
    ld a, (_score_d3)
    add a, #0x30 
    ld 13(ix), a
    ld iy, #stringScore
    ld b, #y_score ;;y
    ld c, #x_score ;; x
    ld a, #color_fondo_letra
    ld e, #color_letra
    call escribir
    ret

draw_instruccion:
;; Instruccion salir de panatalla victory
    ld a, #0
    ld e, #color_letra
    ld iy, #stringInstruccionControles
    ld b, #y_instruccionControles ;;y
    ld c, #x_instruccionControles ;; x
    call escribir
    ret

victory::

    call cpct_akp_stop_asm
    call cpct_disableFirmware_asm
   

    call clean_screen 
    call clean
    call menu_init
    
    ;; YOU WIN
    ld a, #color_resaltado_letra
    ld e, #color_letra
    ld iy, #string_youWin
    ld b, #y_youWin ;;y
    ld c, #x_youWin ;; x
    call escribir

    call draw_score

    call wait
    call wait

    call draw_instruccion

    loop_victory:
    call keys_controles
    jp loop_victory
    
    ret

pause::

    call cpct_akp_stop_asm
    call cpct_disableFirmware_asm

    call clean_screen
    call menu_init

    ld a, #3
    ld e, #color_letra
    ld iy, #stringPause
    ld b, #y_pause ;;y
    ld c, #x_pause ;; x
    call escribir

    call little_wait

    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringInstruccionPause
    ld b, #y_instruccion_pause ;;y
    ld c, #x_instruccion_pause;; x
    call escribir

    ld a, #color_fondo_letra
    ld e, #color_letra
    ld iy, #stringSalirPause
    ld b, #y_salir_pause ;;y
    ld c, #x_salir_pause;; x
    call escribir

    ;;Esperar un pequeÃÂ±o tiempo ---------------
    ;ld a, #100
    ;loop_ret:
    ;    dec a
    ;    halt
    ;    jp nz, loop_ret
    ;;------------------------------------------------------
    
    
    loop_pause:
    call keys_pause
    jp loop_pause

    return_game:
    call clean_screen
    call rendersys_init
    call render_marco
    call interface_init
    call interface_render_lives
    call set_int_handler1
    call get_actual_level
    push de
    ld l, 3(ix)
    ld h, 4(ix)
    call set_music
    pop de 
    call get_loop_game
    jp (hl) ;; salta al bucle de man_game


;draw_game_over:
    ;ld c , #1
    ;call cpct_setVideoMode_asm
;
    ;;;Border 13, SET_PALETTE
    ;cpctm_setBorder_asm HW_WHITE
    ;ld hl, #palette 
    ;ld de , #16
    ;call cpct_setPalette_asm 
;
    ;ld a, #3
    ;ld e, #0x01
    ;ld iy, #stringGameOver
    ;ld b, #y_game_over ;;y
    ;ld c, #x_game_over ;; x
    ;call escribir
    ;ret

;;Drawing the number of level
draw_level_number: 
    ;ld c , #1
    ;call cpct_setVideoMode_asm

    ;;Border 13, SET_PALETTE
    ;cpctm_setBorder_asm HW_BLACK
    ;ld hl, #palette 
    ;ld de , #16
    ;call cpct_setPalette_asm

    ;; Getting the number of level

    ;call get_num_actual_phase
    ;add a, #0x30
    ;ld ix, #string_level
    ;ld 6(ix), a 
    ;call get_num_actual_level
    ;add a, #0x30
    ;ld ix, #string_level
    ;ld 7(ix) , a 
    ;ld iy, #string_level
    ;ld a, #color_resaltado_letra
    ;ld e, #color_letra
    ;ld b, #y_level ;;y
    ;ld c, #x_level ;; x
    ;call escribir

    ;; Cuadrado donde se escribe encima

    ;ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ;ld c, #7 ;; coordenada x
    ;ld b, #10 ;; coordenada y
    ;call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
;
    ;ex de, hl ;; Pasamos el valor a de
    ;ld a, #0xff ;; Color del cuadro
    ;ld c, #43 ;;ancho
    ;ld b, #100 ;;alto
    ;call cpct_drawSolidBox_asm

    ;;----------------------------------


    push hl 
    push de
    ld hl, #_palette_level
    ld de , #16
    call cpct_setPalette_asm

    pop de
    pop hl
    

    
    ;; Escribir palabra LEVEL--------------------------------------------

    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level ;; coordenada x
    ld b, #y_level ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_L
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm

    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level + 9 ;; coordenada x
    ld b, #y_level ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_E
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm

    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level + 18 ;; coordenada x
    ld b, #y_level + 2 ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_V
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm

    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level + 28 ;; coordenada x
    ld b, #y_level ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_E
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm

    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #x_level + 36 ;; coordenada x
    ld b, #y_level ;; coordenada y
    call cpct_getScreenPtr_asm

    ex de, hl ;; Pasamos el valor a de
    ;ld a, #0x33 ;; Color del cuadro
    call get_letter_L
    ld c, #10 ;;ancho
    ld b, #32 ;;alto
    call cpct_drawSprite_asm

    ;;----------------------------------------------------------------------

    ;; Escribir el numero de nivel------------------------------------------
    
    call get_num_actual_level
    call escribe_numero
    ;;----------------------------------------------------------------------
    
    push hl 
    push de
    ld hl, #_main_palette
    ld de , #16
    call cpct_setPalette_asm

    pop de
    pop hl

    ret


clean_screen:
    ld c, #0
    call clean_screen_aux
    ld c, #50
    call clean_screen_aux
    ret

clean_screen_aux:
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ;ld c, #0 ;; coordenada x
    ld b, #0 ;; coordenada y
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    ld a, #0 ;; Color del cuadro
    ld c, #50 ;;ancho
    ld b, #200 ;;alto
    call cpct_drawSolidBox_asm
    ret

wait:
    ;Esperar un pequeÃÂ±o tiempo ---------------
    ld a, #450
    loop_wait:
        dec a
        halt
        halt
        jp nz, loop_wait
    ;------------------------------------------------------
    ret

little_wait:
    ;Esperar un pequeÃÂ±o tiempo ---------------
    ld a, #50
    loop_little_wait:
        dec a
        halt
        jp nz, loop_little_wait
    ;------------------------------------------------------
    ret 

clean::
    call clean_bullets_player
    call clean_bullets_enemy
    call clean_enemies
    call clean_spaceship
    call clean_waves
    call clean_levels
    call clean_screen
    call clean_interface_score
    call clean_items
    ret


game_over::


    call cpct_akp_stop_asm
    call cpct_disableFirmware_asm
   
    call clean_screen 
    call clean
    call menu_init
    
    ;; GAME OVER
    ld a, #color_resaltado_letra
    ld e, #color_letra
    ld iy, #stringGameOver
    ld b, #y_game_over ;;y
    ld c, #x_game_over ;; x
    call escribir

    call draw_score

    call wait
    call wait

    call draw_instruccion


    loop_game_over:
    call keys_controles
    jp loop_game_over
    
    ret

;game_over::
;
;    call clean
;    call draw_game_over
;    call wait
;    call menu_init
;    jp menu


;; Function for drawing the new level
level_output:: 
    call clean_bullets_player
    call clean_bullets_enemy
    ;call bullet_enemy_loop
    call rendersys_update_bullet

    call clean_enemies
    call clean_items
    ;call clean_spaceship
    ;call clean_screen
    ;call render_marco
    call draw_level_number
    call wait
    ;call clean_screen
    ;call rendersys_init
    call render_marco
    call interface_init
    ret

update_marco_izquierda::
    push af
    push bc
    push de
    push hl

    ld de, #CPCT_VMEM_START_ASM

    ld c, #0 ;; coordenada x
    ld b, #0 ;; coordenada y

    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    ld a, #1
    ld c, a ;;ancho
    ld b, #200;;alto

    call get_border01_vertical_sprite
    call cpct_drawSprite_asm
    ld de, #CPCT_VMEM_START_ASM

    ld c, #0 ;; coordenada x
    ld b, #0 ;; coordenada y

    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    ld a, #57
    ld c, a ;;ancho
    ld b, #3;;alto

    call get_border01_horizontal_sprite
    call cpct_drawSprite_asm
    ld de, #CPCT_VMEM_START_ASM

    ld c, #0 ;; coordenada x
    ld b, #197 ;; coordenada y

    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    ld a, #57
    ld c, a ;;ancho
    ld b, #3;;alto

    call get_border01_horizontal_sprite
    call cpct_drawSprite_asm
    ld de, #CPCT_VMEM_START_ASM

    ld c, #56 ;; coordenada x
    ld b, #0 ;; coordenada y

    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    ld a, #1
    ld c, a ;;ancho
    ld b, #200;;alto

    call get_border01_vertical_sprite
    call cpct_drawSprite_asm




    ;; Ahora ponermos el cuadro negro de enmedio

    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld c, #1 ;; coordenada x
    ld b, #5 ;; coordenada y
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    call get_spaceship_sprite
    ld a, #0 ;; Color del cuadro
    ld c, #54 ;;ancho
    ld b, #192 ;;alto
    call cpct_drawSolidBox_asm

    pop hl
    pop de
    pop bc
    pop af
    ret

update_marco_derecha::
    
    push af
    push bc
    push de
    push hl
    ld de, #CPCT_VMEM_START_ASM

    ld c, #57 ;; coordenada x
    ld b, #0 ;; coordenada y

    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de, hl ;; Pasamos el valor a de
    ld a, #23
    ld c, a ;;ancho
    ld b, #200;;alto

    call get_border02_sprite
    call cpct_drawSprite_asm
    pop hl
    pop de
    pop bc
    pop af
    ret

render_marco::  

    call update_marco_derecha
    call update_marco_izquierda

    


    ret