;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
    
;;
;; INPUT SYSTEM
;; 

;; Getting the inputs of the users for updating positions

.include "../input.h.s"
;;Method to update the velocity of the player 
;; INPUT: 
;;    IX = Pointer to entity [0]
;; DESTROYS AF, BC, DE, HL, IX
;; 
.area _DATA
_counterBullet: .db 0

.area _CODE


sys_input_bullet_loop::
    
    loop: 

        ;; ix como el primero
        ;; enemies number check
        ld (_counterBullet), a
        cp #0x00
        ret z

        
        ld a, e_type(ix) ;; MISIL
        cp #0x01
        jp nz, next
        call misil
        jp next


        next:
        ;; call calculate_shoot ;; si el player está abajo dispara
        
        ld a, (_counterBullet)
        dec a
        ret z
        ;;Getting the entity size
        
        ld bc, #entity_size
        add ix, bc
        jp  loop

    ret


misil:
    ld a, e_y(ix)
    sub #178
    ret c

    ld iy, #bullet_misil_broken

    ld a, e_x(ix)
    add #-2
    ld e_x(iy), a

    ld hl, #bullet_misil_broken
    call create_bullet_enemy

    ld iy, #bullet_misil_broken2

    ld a, e_x(ix)
    add #2
    ld e_x(iy), a

    ld hl, #bullet_misil_broken2
    call create_bullet_enemy


    ld iy, #bullet_misil_broken3
    ld a, e_x(ix)
    ld e_x(iy), a

    ld hl, #bullet_misil_broken3
    call create_bullet_enemy

    ld iy, #bullet_misil_broken4
    ld a, e_x(ix)
    ld e_x(iy), a
    ld hl, #bullet_misil_broken4
    call create_bullet_enemy


    call delete_man_bullet_enemy


    ret


