    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
.area _DATA
_counter2_restore: .db 0
_counter1: .db 0
_counter2: .db 0
_dir_copy: .dw 0 
_auxIX: .dw 0
_auxIY: .dw 0

_auxLife: .db 0
_auxEyeBoss: .db 0
_no_delete: .db 0

.area _CODE 
;;INPUT
;;       A: Number of FIRST elements
;;       B: Number of SECOND elements 
;;      IX: First array of elements
;;      IY: Second array of elements
;;      HL: Collision method

check_collisions::
    ld (_counter1), a
    ld (_dir_copy) , iy 
    ld a, b
    ld (_counter2), a
    ld (_counter2_restore) , a 
    cp #0x00
    ret z

    loop_check_collisions:

    ld a , (_counter1)
    cp #0x00
    ret z
    ld iy, (_dir_copy)
    ld a, (_counter2_restore)
    ld (_counter2) , a
    call check_collisions_aux
    
    ld a , (_counter1)
    dec a
    ret z
    ld (_counter1), a

    ld bc, #entity_size
    add ix, bc

    jp loop_check_collisions



check_collisions_aux:

    ld a, (_counter2)
    cp #0x00
    ret z
    
    loop_collision:

    
    ;;COMPROBAMOS EJE X -------------------------------

    ;; A (x(ix) + w(ix)) < B (x(iy)) -> no colisiona
    ld a, e_x(ix)
    add e_w(ix)
    sub e_x(iy)
    jr c, next ;no collision

    ;; C (x(iy) + w(iy)) < D (x(ix)) -> no colisiona
    ld a, e_x(iy)
    add e_w(iy)
    sub e_x(ix)
    jr c, next ;no collision

    ;;--------------------------------------------------

    ;;COMPROBAMOS EJE Y---------------------------------

    ;; A (x(ix) + w(ix)) < B (x(iy)) -> no colisiona
    ld a, e_y(ix)
    add e_h(ix)
    sub e_y(iy)
    jr c, next ;no collision

    ;; C (x(iy) + w(iy)) < D (x(ix)) -> no colisiona
    ld a, e_y(iy)
    add e_h(iy)
    sub e_y(ix)
    jr c, next ;no collision


    ;;--------------------------------------------------
    
    jp (hl)

    next:
    ld a, (_counter2)
    dec a
    ld (_counter2), a
    ret z

    
    ld bc, #entity_size
    add iy, bc


    jp loop_collision



collision_bullet_player:
    
    ld a, #0
    ld (_no_delete), a

    call check_especial_collision

    ld (_auxIY), iy
    ld (_auxIX), ix
    ld ix, (_auxIY)

    ld a, e_lives(ix)
    dec a
    ld e_lives(ix), a
    jp nz, no_dead_enemy
    push hl
    ;; Cambiar sprite enemgio a muerte y pasar el render

    call get_enemy_Death_sprite

      
    ld 6(ix), l
    ld 7(ix), h
    push ix
    
    
    
   
    call cpct_waitVSYNC_asm
    call get_enemies_array_position ;;Cargamos en ix la posiciï¿½n del array
    call get_enemies_created ;; Cargamos el nï¿½mero de entidades que tenemos creadas
    call rendersys_update_enemy ;;Lo cargamos en pantalla
    pop ix
    pop hl
    halt
    halt
    halt
    call cpct_waitVSYNC_asm
    call cpct_waitVSYNC_asm
    call delete_man_enemies
    ;ret
    no_dead_enemy:
    
    ld ix, (_auxIX)
    ;jp next
    ;jp collisions_loop
    pop hl

    ld a, (_no_delete)
    or #0x00
    jp nz, no_delete
    
    call delete_man_bullet_player

    no_delete:
    call inc_score
    ret

collision_bullet_enemy:

    call delete_man_bullet_enemy

    ld (_auxIY), iy
    ld (_auxIX), ix
    ld ix, (_auxIY)

    ld a, e_type(ix)
    cp #0x01
    jp z, no_damage1

    ld a, e_lives(ix)
    dec a
    ld e_lives(ix), a
    jp z, spaceship_dead  

    push hl
    ;; Cambiar sprite player a daÃ±ado y pasar el render
    call get_nextSpaceship_Sprite

    ld a, #1
    ld e_type(ix), a
      
    ld 6(ix), l
    ld 7(ix), h
    ;push ix
    ;call get_spaceship_array_position ;;Cargamos en ix la posicion del array
    ;call get_spaceships_created ;; Cargamos el numero de entidades que tenemos creadas
    ;call rendersys_update_spaceship ;;Lo cargamos en pantalla
;
    ;call cpct_waitVSYNC_asm
    ;pop ix 
    pop hl
    ;;Aqui quÃ© hacer si quedan vidas despuÃ©s
    ;;de recibir un disparo
    ;call wait
    call interface_render_lives
    
    ; ld e_x(ix), #27
    ; ld e_y(ix), #150

    no_damage1:
    pop hl
    ret
    ;jp collisions_loop
    ;jp next

collision_enemy_player:

    ld a, e_type(ix)
    cp #0x01
    jp z, no_damage2

    ld a, e_lives(ix)
    dec a
    ld e_lives(ix), a
    jp z, spaceship_dead
    push hl

    ;;AquÃ­ quÃ© hacer si quedan vidas despuÃ©s
    ;;de chocar
    ;; Cambiar sprite player a daÃ±ado y pasar el render
    call get_nextSpaceship_Sprite

    ld a, #1
    ld e_type(ix), a
      
    ld 6(ix), l
    ld 7(ix), h
    ;push ix 
    ;call get_spaceship_array_position ;;Cargamos en ix la posicion del array
    ;call get_spaceships_created ;; Cargamos el numero de entidades que tenemos creadas
    ;call rendersys_update_spaceship ;;Lo cargamos en pantalla 
;
    ;call cpct_waitVSYNC_asm
    ;pop ix
    pop hl
    ;call wait
    call interface_render_lives
    ;ld e_x(ix), #27
    ;ld e_y(ix), #150

    no_damage2:
    pop hl
    ret
    ;jp collisions_loop
    ;jp next


collision_item:
    ld (_auxIY), iy
    ld (_auxIX), ix
    ld ix, (_auxIY)

    ld a, e_type(ix)

    cp #0x00
    jp nz, item_bullets

    call delete_man_items
    ld ix, (_auxIX)
    call collision_item_1UP

    item_bullets:
    cp #0x01
    jp nz, item_hourglass
    call delete_man_items
    ld ix, (_auxIX)
    call collision_item_bullets

    item_hourglass:
    call delete_man_items
    ld ix, (_auxIX)
    call collision_item_hourglass

    ret

collision_item_hourglass:

    ld a, #1
    ld e_type(ix), a

    call set_invencible_item

    ld a, #3
    ld (_current_sprite), a

    ret

collision_item_bullets:

    ld a, #2
    ld e_type(ix), a

    ret

collision_item_1UP:
    push af
    ld a, e_lives(ix)
    cp #0x05
    jp z, vidasAlMaximo
    inc a
    ld e_lives(ix), a

    call get_nextSpaceship_Sprite
    ld 6(ix), l
    ld 7(ix), h
    
    vidasAlMaximo:
    call update_marco_derecha
    call interface_render_lives
    pop af
    pop hl
    ret

spaceship_dead:
    push hl
    ;; Cambiar sprite player a muerte y pasar el render
    call get_spaceshipDeath_sprite
      
    ld 6(ix), l
    ld 7(ix), h
    push ix
    call get_spaceship_array_position ;;Cargamos en ix la posicion del array
    call get_spaceships_created ;; Cargamos el numero de entidades que tenemos creadas
    call rendersys_update_spaceship ;;Lo cargamos en pantalla 

    call cpct_waitVSYNC_asm
    pop ix
    pop hl
    call wait
    call game_over

wait:
;Esperar un pequeÃ±o tiempo ---------------
    ld a, #35
    loop_ret:
        dec a
        halt
        halt
        jp nz, loop_ret
    ret
;------------------------------------------------------


check_especial_collision:
    ld a, e_type(iy)
    cp #0x07
    call z, eyeBoss_collision
    ret

eyeBoss_collision:

    ld a, (_eye_closed)
    or #0x00
    ret z

    ld a, #1
    ld (_no_delete), a

    ld a, e_lives(iy)
    inc a
    ld e_lives(iy), a

    ld a, (_auxEyeBoss)
    xor #1
    ld (_auxEyeBoss), a
    jp z, asignaMenos1
    ld e_vx(ix), a
    jp asignaY

    asignaMenos1:
    ld a, #-1
    ld e_vx(ix), a

    asignaY:
    ld a, #2
    ld e_vy(ix), a

    ret



get_collision_bullet_player::
    ld hl, #collision_bullet_player
    ret

get_collision_bullet_enemy::
    ld hl, #collision_bullet_enemy
    ret

get_collision_enemy_player::
    ld hl, #collision_enemy_player
    ret

get_collision_item::
    ld hl, #collision_item
    ret

get_nextSpaceship_Sprite::
    push af
    ;; obtenemos el sprite de la nave, que cambiará si le quedan 2 vidas o menos
    ld a, e_lives(ix)
    sub #2
    jp c, sprite2
    jp z, sprite1
    call get_spaceship_sprite
    
    ld a, #0
    ld (_current_sprite), a

    pop af
    ret
    sprite1:
    call get_spaceshipDamaged1_sprite

    ld a, #1
    ld (_current_sprite), a

    pop af
    ret
    sprite2:
    call get_spaceshipDamaged2_sprite

    ld a, #2
    ld (_current_sprite), a

    pop af
    ret



get_enemy_Death_sprite:
        
        ld a, e_type(ix)
        cp #0x00
        jp nz, type_2_bullets
        call get_enemyDeath_sprite
        jp next1

        ; type_laser:
        ; cp #0x01
        ; jp nz, type_2_bullets
        ; call get_enemyDeath_sprite
        ; jp next1

        type_2_bullets:
        cp #0x01
        jp nz, type_not_shoot
        call get_enemy_zygon1_death
        jp next1

        type_not_shoot: 
            cp #0x03
            jp nz, type_red
            call get_enemy_zygon1_death
            jp next1
        
        type_red: ;; no tiene sprite de muerte
            cp #0x04
            jp nz, type_boss1
            call get_enemy_sprite_red
            jp next1

        type_boss1: 
            cp #0x05
            jp nz, type_son
            call get_enemy_prite_boss1_death
            jp next1

        type_son: 
            cp #0x06
            jp nz, type_eye_boss
            call get_enemySon_death_sprite
            jp next1 

        type_eye_boss:
            cp #0x07
            jp nz, type_eye_son
            call get_enemyEyeBoss_death_sprite
            jp next1
        
        type_eye_son:
            cp #0x08
            jp nz, type_SideMan
            call get_enemyEyeBoss_son_death_sprite
            jp next1
        type_SideMan:
            cp #0x09
            jp nz, type_boss_spaceship
            call get_enemySideMan_sprite_death
            jp next1

        type_boss_spaceship:
            cp #10
            jp nz, next1
            call get_enemy_boss_spaceship_death_sprite
            jp next1
        next1:
        ret