    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
;;
;; INPUT SYSTEM
;; 

;; Getting the inputs of the users for updating positions

.include "../input.h.s"
;;Method to update the velocity of the player 
;; INPUT: 
;;    IX = Pointer to entity [0]
;; DESTROYS AF, BC, DE, HL, IX
;; 
.area _DATA
_counterEnemy: .db 0
_AuxBossMovement5: .db 10
_AuxBossMovement7: .db 10
_AuxBossMovement10: .db 1

t_closed = 100
t_open = 100
_eye_closed:: .db 0
_cont_eye_open: .db #t_open
_cont_eye_closed: .db #t_closed

t_wave_eye_son = 30
_cont_wave_eye_son: .db #t_wave_eye_son
_eye_son_wave: .db 0

t_boss_spaceship = 30
_cont_boss_spaceship: .db #t_boss_spaceship

_typeOfMisil: .db 0 

_typeOfSmartMissile: .db 0

t_smart_missile = 3
_cont_smart_missile: .db 3

t_spaceship_big = 50
_cont_spaceship_big: .db #t_spaceship_big


.area _CODE


sys_input_enemy_loop::
    
    loop: 

        ;; ix como el primero
        ;; enemies number check
        ld (_counterEnemy), a
        cp #0x00
        ret z

        
        ld a, e_type(ix)
        cp #0x00
        jp nz, type_2_bullets
        call shootEnemy ;; dispara cuando puede
        jp next

        type_2_bullets:
        cp #0x01
        jp nz, type_enemy_not_shoot
        call shootEnemy_2_bullets
        ;call shootEnemy_laser
        jp next

        type_enemy_not_shoot:
            cp #0x03
            jp nz, boss_type5
            jp next

        boss_type5:
            cp #0x05
            jp nz, boss_type6
            ld a, (_AuxBossMovement5)
            cp #00
            jp nz, BossNotTurn5
            ld a, #10
            ld (_AuxBossMovement5), a
            ld a, 4(ix)                    ;; movimiento de boss
            neg
            ld 4(ix), a
            ld a, e_vy(ix)                    ;; movimiento de boss
            neg
            ld e_vy(ix), a
            jr shootBossT5Line
            BossNotTurn5:
            dec a
            ld (_AuxBossMovement5), a
                
            shootBossT5Line:
            call shootBossT5    ;; disparo de boss
            jp next
            
        boss_type6:
            cp #0x06
            jp nz, boss_type7

            call perseguir

            jp next

        boss_type7:
            cp #0x07
            jp nz, type8
            call eye_boss
            jp next

        type8:
            cp #0x08
            jp nz, sideman_shot
            jp next

        sideman_shot:
            cp #0x09
            jp nz, type_boss_spaceship
            call shootsideman 
            jp next
        
        type_boss_spaceship:
            cp #10
            jp nz, type_spaceship_big
            call boss_spaceship
            jp next

        type_spaceship_big:
            cp #11
            jp nz, type_smart_missile
            call shootEnemy_spaceship_big
            call spaceship_big
            jp next

        type_smart_missile:
            ld a, e_type(ix) ;; MISIL
            cp #12
            jp nz, next
            call smart_missile
            jp next


        ;;El tipo 8 es el eyeBoss_son, pero no necesita nada aquí

        type_laser:
        call shootEnemy

        next:
        ;; call calculate_shoot ;; si el player está abajo dispara
        
        ld a, (_counterEnemy)
        dec a
        ret z
        ;;Getting the entity size
        
        ld bc, #entity_size
        add ix, bc
        jp  loop

    ret

eye_boss:
    ld a, (_AuxBossMovement7)
    cp #00
    jp nz, BossNotTurn7
    ld a, #20
    ld (_AuxBossMovement7), a
    ld a, 4(ix)                    ;; movimiento de boss
    neg
    ld 4(ix), a
    jp blink
    
    BossNotTurn7:
    dec a
    ld (_AuxBossMovement7), a

    blink:
    ld a, (_eye_closed)
    or #0x00
    jp z, no_closed

    call eye_son_attack

    ld a, (_cont_eye_closed)
    dec a
    ld (_cont_eye_closed), a
    ret nz
    ld a, #0
    ld (_eye_closed), a
    ld a, #t_closed
    ld (_cont_eye_closed), a
    ret

    no_closed:

    call shootEnemy_eyeBoss

    ld a, (_cont_eye_open)
    dec a
    ld (_cont_eye_open), a
    ret nz
    ld a, #1
    ld (_eye_closed), a
    ld a, #t_open
    ld (_cont_eye_open), a

    ret

eye_son_attack:

    ld a, (_cont_wave_eye_son)
    dec a
    ld (_cont_wave_eye_son), a
    ret nz

    ld a, #t_wave_eye_son
    ld (_cont_wave_eye_son), a

    ld a, (_eye_son_wave)
    xor #1
    ld (_eye_son_wave), a
    jp z , wave2

    ld hl, #eye_son_1
    call create_man_enemies
    ; ld hl, #eye_son_2
    ; call create_man_enemies
    ld hl, #eye_son_3
    call create_man_enemies
    ret

    wave2:
    ld hl, #eye_son_4
    call create_man_enemies
    ld hl, #eye_son_5
    call create_man_enemies
    ;ld hl, #eye_son_6
    ;call create_man_enemies

    ret

boss_spaceship:
    ;ld a, (_AuxBossMovement10)
    ;cp #00
    ;jp nz, BossNotTurn10
    ;ld a, #1
    ;ld (_AuxBossMovement10), a
    ;ld a, 4(ix)                    ;; movimiento de boss
    ;neg
    ;ld 4(ix), a
    ;jp continue10
    
    ;BossNotTurn10:
    ;ld a, (_AuxBossMovement10)
    ;dec a
    ;ld (_AuxBossMovement10), a

    continue10:

    ld a, (_typeOfMisil)
    xor #0x01
    jp z, misil_p

    call shootEnemy_boss_spaceship_misil
    
    misil_p:

    call shootEnemy_boss_spaceship_misil_p

    ret

spaceship_big:


    ld a, (_cont_spaceship_big)
    dec a
    ld (_cont_spaceship_big), a
    ret nz

    ld a, #t_spaceship_big
    ld (_cont_spaceship_big), a

    ld a, (_typeOfSmartMissile)
    xor #0x01
    ld (_typeOfSmartMissile), a
    jp z, second_missile

    ld iy, #bullet_smart_missile
    ld a, e_x(ix)
    add #10
    ld e_x(iy), a
    ld a, e_y(ix)
    add #35
    ld e_y(iy), a 

    ld hl, #bullet_smart_missile
    call create_man_enemies
    ret
    
    second_missile:
    
    ld iy, #bullet_smart_missile
    ld a, e_x(ix)
    ld e_x(iy), a
    ld a, e_y(ix)
    add #35
    ld e_y(iy), a 

    ld hl, #bullet_smart_missile
    call create_man_enemies


    ret
    

perseguir:

    ;perseguir
    
    ;push ix
    ;push hl
    ;push iy

    call get_spaceship_array_position_IY

    ld a, e_x(ix)
    ld b, e_x(iy)
    sub b
    jp nc, left

    ;right
    ld a, #1
    ld e_vx(ix), a
    ret

    left:

    ld b, e_x(ix)
    ld a, e_x(iy)
    sub b
    jp nc, recto

    ld a, #-1
    ld e_vx(ix), a
    ret

    recto:
    ld a, #0
    ld e_vx(ix), a


    ;pop iy
    ;pop hl
    ;pop ix

    ret

smart_missile:

    ld a, (_cont_smart_missile)
    dec a
    ld (_cont_smart_missile), a
    ret nz

    ld a, #t_smart_missile
    ld (_cont_smart_missile), a


    call get_spaceship_array_position_IY

    ld a, e_x(ix)
    add #2
    ld b, e_x(iy)
    sub b
    jp nc, left

    ;right
    ld a, #1
    ld e_vx(ix), a
    ret

    left_missile:

    ld b, e_x(ix)
    add #-2
    ld a, e_x(iy)
    sub b
    jp nc, recto

    ld a, #-1
    ld e_vx(ix), a
    ret

    recto_missile:
    ld a, #0
    ld e_vx(ix), a

    ret

;;Method to set the movement
; sys_input_update_enemy::
; ;; Reset Velocities

;     ld 4(ix), #0x00   ;; Vx
;     ld 5(ix), #2  ;;  Moving down
    
;     jr calculate_X
;     after_calculate_X:

;     ld 4(ix), a
;     ;;ld 4(ix), #-1 
;     ;;ld 4(ix), #1  
    

;     ret

; calculate_shoot:
;     push ix 
;     call get_spaceship_array_position
;     ld b, 0(ix)
;     pop ix
;     ld c, 0(ix)
;     ld a, c
;     sbc a, b

;     ;; Calculator deactivated
;     jr z,   targeted
;     ret
;     targeted:
;     ;ld a, #0   ;;  not moving X
;     call shootEnemy
;     ret


