    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------

.area _DATA

t_flick = 8 ;Tiempo entre parpadeo en el estado invencible
t_invencible = 150 ;El tiempo que dura ser invencible
t_wave = 35 ; NO TOCAR, hace que el time puesto en cada oleada sea equivalente a segundos (a ojo) 
t_shoot = 15 ;El retardo de disparo por defecto
t_shoot_hm = 30 ;El retardo de disparo en hard mode 
t_fast_shoot = 7 ;El retardo de disparo en fast shoot
t_fast_shoot_state = 150 ;El tiempo que dura fast_shoot
t_invencible_item = 500


_counter_music: .db 2

_count_flick: .db #t_flick
_count_invencible: .db #t_invencible

_control_shoot:: .db 1 ; 0-> no se dispara, 1 -> se dispara 
_count_shoot: .db #t_shoot

_count_fast_shoot: .db #t_fast_shoot_state

_wave: .db 0
_count_wave1: .db #t_wave
_count_wave2: .db 0
;;El segundo contador son las veces que queremos que se repita el primero
;;hasta lanzar la suiguiente oleada. Se asigna la lanzar las wave

_invencible: .db 0

.area _CODE

interruptions_init::
    ld a, #2
    ld (_counter_music), a

    ld a, #t_flick
    ld (_count_flick), a

    ld a, #t_invencible
    ld (_count_invencible), a

    ld a, #1
    ld (_control_shoot), a ; 0-> no se dispara, 1 -> se dispara

    call get_opcion
    cp #0x01
    jp z, hm_init_shot

    ld a, #t_shoot
    ld (_count_shoot), a

    hm_init_shot:
    ld a, #t_shoot_hm
    ld (_count_shoot), a


    ld a, #t_fast_shoot_state
    ld (_count_fast_shoot), a

    ld a, #0
    ld (_wave), a

    ld a, #t_wave
    ld (_count_wave1), a

    ld a, #0
    ld (_count_wave2), a

    ld a, #0
    ld (_invencible), a
    
    ret

int_handler1:
    push af
    push bc
    push de
    push hl    
    push ix

    ;; Actualizar estados

    ;; Retardo disparo-------------
    ld a, (_control_shoot)
    cp #0x00
    jp nz, no_shoot

    ld a, (_count_shoot)
    dec a
    ld (_count_shoot), a
    jp nz, no_shoot

    ld a, #1
    ld (_control_shoot), a

    call get_spaceship_array_position
    ld a, e_type(ix)

    cp #0x02
    jp nz, default_shoot

    ld a, #t_fast_shoot
    ld (_count_shoot), a
    jp no_shoot

    default_shoot:
    call get_opcion
    cp #0x01
    jp z, hm
    
    ld a, #t_shoot
    ld (_count_shoot), a
    jp no_shoot

    hm:
    ld a, #t_shoot_hm
    ld (_count_shoot), a 
    ;;-----------------------------

    no_shoot:

    ;; Contador Invencible-------------
    call get_spaceship_array_position
    ld a, e_type(ix)
    
    ld (_invencible), a
    cp #0x01
    jp nz, fast_shoot

    ld a, #t_fast_shoot
    ld (_count_fast_shoot), a

    ld a, (_count_invencible)
    dec a
    ld (_count_invencible), a
    cp #0x00
    jp nz, next1

    ld a, #0
    ld e_type(ix), a
    ld a, #t_invencible
    ld (_count_invencible), a 

    call get_nextSpaceship_Sprite
    ld 6(ix), l
    ld 7(ix), h

    jp next1
    ;;----------------------------------

    fast_shoot:

    ;; Contador Fast shoot--------------
    cp #0x02
    jp nz, next1
    
    ld a, (_count_fast_shoot)
    dec a
    ld (_count_fast_shoot), a
    cp #0x00
    jp nz, next1

    ld a, #0
    ld e_type(ix), a
    ld a, #t_fast_shoot_state
    ld (_count_fast_shoot), a
    ;;----------------------------------

    next1:

    call set_int_handler2

    pop ix
    pop hl
    pop de 
    pop bc
    pop af

    ei
    reti


int_handler2:
    push af
    push bc
    push de
    push hl

    ;;Invencible-----------------
    ld a, (_invencible)
    cp #0x01
    jp nz, next2

    ld a, (_count_flick)
    dec a
    ld (_count_flick), a
    cp #0x00
    jp nz, next2

    ld a, (_black)
    or #0x00
    jp z, black

    ld a, #0
    ld (_black), a

    ld a, #t_flick
    ld (_count_flick), a

    jp next2

    black:
    ld a, #1
    ld (_black), a

    ld a, #t_flick
    ld (_count_flick), a
    ;----------------------------

    next2:

    call set_int_handler3

    pop hl
    pop de 
    pop bc
    pop af

    ei
    reti


int_handler3:
    push af
    push bc
    push de
    push hl

    ;; Music-----------------------
    ld a, (_counter_music)
    dec a 
    jp nz, normal
    call cpct_akp_musicPlay_asm
    ld a, #0x02
    normal: 
        ld (_counter_music), a
    ;;-----------------------------


    ;; Waves--------------------------------------------
    ld a, (_wave)
    or #0x00 ;; hay que comprobar el tiempo de oleada?
    jp z, next3

    ;;Sí
    ld a, (_count_wave1)
    dec a
    ld (_count_wave1), a
    or #0x00
    jp nz, next3

    ld a, #t_wave
    ld (_count_wave1), a

    ld a, (_count_wave2)
    dec a
    ld (_count_wave2), a
    or #0x00
    jp nz, next3

    ld a, #1
    ld (_next_wave), a
    ld a, #0
    ld (_wave), a
    ;;---------------------------------------------------
    
    next3:
    call set_int_handler4


    pop hl
    pop de 
    pop bc
    pop af

    ei
    reti


int_handler4:
    push af
    push bc
    push de
    push hl



    call set_int_handler5

    pop hl
    pop de 
    pop bc
    pop af

    ei
    reti


int_handler5:
    push af
    push bc
    push de
    push hl


    call set_int_handler6


    pop hl
    pop de 
    pop bc
    pop af

    ei
    reti


int_handler6:
    push af
    push bc
    push de
    push hl


    call set_int_handler1


    pop hl
    pop de 
    pop bc
    pop af

    ei
    reti


set_invencible_item::

    ld a, #t_invencible_item
    ld (_count_invencible), a

    ret

set_time::
    ld (_count_wave2), a
ret



wave_begins::
    ld a, #1
    ld (_wave), a
ret


set_int_handler1::
    ld hl, #0x38
    ld (hl), #0xC3
    inc hl
    ld (hl), #<int_handler1
    inc hl
    ld (hl), #>int_handler1
    inc hl
    ld (hl), #0xC9
    ret

set_int_handler2::
    ld hl, #0x38
    ld (hl), #0xC3
    inc hl
    ld (hl), #<int_handler2
    inc hl
    ld (hl), #>int_handler2
    inc hl
    ld (hl), #0xC9
    ret

set_int_handler3::
    ld hl, #0x38
    ld (hl), #0xC3
    inc hl
    ld (hl), #<int_handler3
    inc hl
    ld (hl), #>int_handler3
    inc hl
    ld (hl), #0xC9
    ret

set_int_handler4::
    ld hl, #0x38
    ld (hl), #0xC3
    inc hl
    ld (hl), #<int_handler4
    inc hl
    ld (hl), #>int_handler4
    inc hl
    ld (hl), #0xC9
    ret

set_int_handler5::
    ld hl, #0x38
    ld (hl), #0xC3
    inc hl
    ld (hl), #<int_handler5
    inc hl
    ld (hl), #>int_handler5
    inc hl
    ld (hl), #0xC9
    ret

set_int_handler6::
    ld hl, #0x38
    ld (hl), #0xC3
    inc hl
    ld (hl), #<int_handler6
    inc hl
    ld (hl), #>int_handler6
    inc hl
    ld (hl), #0xC9
    ret


