    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
;;
;; PHYSICS SYSTEM
;; 
.area _DATA 
s_width = 56
s_height = 196
_counter: .db 0


.area _CODE 
;_pointer_error_carry_x: .dw 0
;_pointer_error_carry_y: .dw 0
;;Method to update an entity position 
;; INPUT 
;;  HL: Pointer to the errorCarry X
;;  DE: Pointer to the erorrCarry Y
;;  IX: Pointer to the first entity to update
;;  A: Number of entities to update position
sys_update_position_entities:: 
    ;ld (_pointer_error_carry_x) , hl
    ;ld (_pointer_error_carry_y) , de
    loop: 
        ;push af
        ld (_counter) , a
        cp #0x00
        ret z
        
        ;push hl
        ;call check_especial_movement
        ;pop hl

        update:
        ;First of all, we put the last position of the entity with the color of the background
        ld a, #s_width + 1 -1 ;; Getting the width of the screen
        sub 2(ix)
        ld c, a 
        ld a , 0(ix) 
        add 4(ix)
        add #-1 ;; Para el marco
        cp c ;;Comparamos el valor de x (m�ximo ancho posible) , con el valor de  la suma de x + Vx
        jr nc, jumpX
        jr notJumpX 
        jumpX: 
        jp (hl)
        notJumpX: 
        ;jr nc, (_pointer_error_carry_x);;Cuando no producimos acarreo, es porque nuestra x es inv�lida, dado que no nos ha devuelto un resultado negativo
        ;;Si la x es v�lida
        add #1 ;; Para el marcold (_counter) , a
        cp #0x00
        ret z
        ld 0(ix) , a
        resultX: 
        ld a, #s_height + 1  -4;;Altura
        sub 3(ix)
        ld c, a

        ld a, 1(ix) ;;Y
        ld b, 5(ix) ;; VY
        add a,b 
        add #-4 ;; Para el marco
        cp c 
        ex de, hl
        jr nc, jumpY
        jr notJumpY
        jumpY: 
        jp (hl)
        notJumpY: 
        add #4 ;; Para el marco
        ld 1(ix) , a
        resultY: 
        ld a, (_counter)
        dec a
        ret z
        ;;Getting the entity size
        
        ld bc, #entity_size
        add ix, bc
        jr  loop
    error_carryX_spaceship: 
        ;;  When the carry is not activateds 
        ld a, 4(ix)
        neg
        ld 4(ix), a
        jr resultX
    error_carryY_spaceship: 
        ;;  When the carrys is activated, the entity is detroyed 
        ld a, b
        neg 
        ld 5(ix) , a
        jr resultY

    error_carryY_enemy: 
        ;;  When the carrys is activated, the entity is detroyed   
        
        ld a, e_type(ix)
        cp #10
        jp nz, type11
        ld a, e_vx(ix)
        neg
        ld e_vx(ix), a
        ret
        type11:
        ld a, e_type(ix)
        cp #11
        jp nz, delete
        ld a, e_vx(ix)
        neg
        ld e_vx(ix), a
        ret
        delete:
        ;; destruccion y renacimiento
        call delete_man_enemies

        ;call create_enemy_again

        ret
    error_carryY_bullet_player: 
        call delete_man_bullet_player
        ret
    
    error_carryY_bullet_enemy:
        call delete_man_bullet_enemy
        ret
    error_carryY_item::
        call delete_man_items
        ret

    get_spaceship_error_y:: 
        ld de, #error_carryY_spaceship
        ret

    get_spaceship_error_x:: 
        ld hl, #error_carryX_spaceship
        ret
    
    get_enemy_error_x:: 
        ld hl, #error_carryY_enemy
        ret 
    get_enemy_error_y:: 
        ld de, #error_carryY_enemy
        ret

    get_bullet_player_error_y:: 
        ld de, #error_carryY_bullet_player
        ret
    
    get_bullet_player_error_x:: 
        ld hl, #error_carryY_bullet_player
        
        ret

    get_bullet_enemy_error_y::
        ld de, #error_carryY_bullet_enemy
        ret
    
    get_bullet_enemy_error_x::
        ld hl, #error_carryY_bullet_enemy
        ret

    get_item_error_x::
        ld hl, #error_carryY_item
        ret

    get_item_error_y::
        ld de, #error_carryY_item
        ret


check_especial_movement:
    ld a, e_type(ix)
    cp #0x06
    ret nz

    call perseguir
    ret

perseguir:

    ;perseguir
    
    ;push ix
    ;push hl
    ;push iy

    call get_spaceship_array_position_IY

    ld a, e_x(ix)
    ld b, e_x(iy)
    sub b
    jp nc, left

    ;right
    ld a, #1
    ld e_vx(ix), a
    ret

    left:

    ld b, e_x(ix)
    ld a, e_x(iy)
    sub b
    jp nc, recto

    ld a, #-1
    ld e_vx(ix), a
    ret

    recto:
    ld a, #0
    ld e_vx(ix), a


    ;pop iy
    ;pop hl
    ;pop ix

    ret
