    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
;;
;; INPUT SYSTEM
;; 

;; Getting the inputs of the users for updating positions

.include "cpctelera.h.s"
.include "../input.h.s"

;;Method to update the velocity of the player 
;; INPUT: 
;;    IX = Pointer to entity [0]
;; DESTROYS AF, BC, DE, HL, IX
;; 
.area _CODE 
;;Method to set the movement
sys_input_update_spaceship::
;; Reset Velocities
    ld 4(ix), #0x00 
    ld 5(ix) , #0x00
    
    call cpct_scanKeyboard_f_asm ;;Scanning the keyboard
    ld hl , #Key_O
    call cpct_isKeyPressed_asm ;; Checking if key O is pressed
    jr z, O_NotPressed
    ;;If it's pressed
    ld 4(ix) , #-1 ;; Moving to the left
    O_NotPressed:
        ;;Then, we have to check the another keys 
        ld hl, #Key_P
        call cpct_isKeyPressed_asm
        jr z, P_NotPressed
        ;; If it's pressed
        ld 4(ix) , #1 ;;Moving to the right
    P_NotPressed: ;;When the action is dgoing up
        ld hl, #Key_A
        call cpct_isKeyPressed_asm
        jr z, A_NotPressed
        ld 5(ix), #2
    A_NotPressed: 
        ld hl, #Key_Q
        call cpct_isKeyPressed_asm
        jr z, Q_NotPressed
        ld 5(ix), #-2
    Q_NotPressed: ;;Checking shoot action 
            ld a, (_control_shoot) ;; interruptions
            cp #0x00
            jp z, Shoot_NotPressed

            ld hl, #Key_Shoot
            call cpct_isKeyPressed_asm
            jr z, Shoot_NotPressed
            call shootPlayer
            
            ld a, #0
            ld (_control_shoot), a
    
    Shoot_NotPressed: 
        ld hl, #Key_Esc
        call cpct_isKeyPressed_asm
        jr z, Esc_NotPressed
        jp pause
        ;jp game_over
        ;jp victory
        Esc_NotPressed:
        ret
        
