    ;;;------------------------- LICENSE NOTICE -----------------------------
    ;; This file is part of OVNI SAMURAI: an Amstrad CPC game developed by REAL BACON STUDIO
    ;;
    ;;     Copyright (C) 2020 Álvaro Sirvent, Aarón Picó, Samuel Arévalo 
    ;;
    ;;     This program is free software: you can redistribute it and/or modify
    ;;     it under the terms of the GNU General Public License as published by
    ;;     the Free Software Foundation, either version 3 of the License, or
    ;;     (at your option) any later version.
    ;;
    ;;     This program is distributed in the hope that it will be useful,
    ;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;     GNU General Public License for more details.
    ;;
    ;;     You should have received a copy of the GNU General Public License
    ;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
    ;;
    ;; Contact REAL BACON STUDIO on:
    ;;
    ;:     Twitter:    https://twitter.com/realbaconstudio
    ;:     E-mail:
    ;:         Samuel Arévalo : arevalosamuel1608@gmail.com
    ;:         Álvaro Sirvent: alvaro231199@gmail.com
    ;;         Aarón Picó:     picoaaron@gmail.com
    ;;;----------------------------------------------------------------------
;;
;; RENDER SPACESHIP SYSTEM
;; 
;;Sistema para pintar las entidades

.area _DATA
_black:: .db 0
_current_sprite:: .db 0

.area _CODE
;;Method to draw all the entities in the register
;;INPUT
;;  IX: Pointer to first entity to render
;;  A: Number of entities to render
rendersys_update_spaceship::
    push ix
    push af
    call get_spaceship_array_position
    ld a, e_type(ix)
    cp #0x01
    jp nz, render
        ;; Estado invencible (parpadeo)
        ld a, (_black)
        or #0x00
        jp nz, black

        sprite:
            ld a, (_current_sprite)
            cp #0x00
            jp nz, damaged1
            call get_spaceship_sprite
            jp next

            damaged1:
            cp #0x01
            jp nz, damaged2
            ;; Comprueba aqui izquierada o derecha
            call get_spaceshipDamaged1_sprite
            jp next
            
            damaged2:
            cp #0x02
            jp nz, gold
            ;; Comprueba aqui izquierda o derecha
            call get_spaceshipDamaged2_sprite
            jp next

            gold:
            call get_spaceshipImmortal

            next:
            ld 6(ix), l
            ld 7(ix) , h
            jp render
    
        black:
        call get_spaceshipBlack_sprite
        ld 6(ix), l
        ld 7(ix) , h


    render:
    pop af
    pop ix
    call rendersys_update
    ret

